VirtualBox

source: vbox/trunk/configure@ 77910

Last change on this file since 77910 was 77135, checked in by vboxsync, 5 years ago

configure: FreeBSD fix

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 77.8 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2019 Oracle Corporation
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License (GPL) as published by the Free Software
12# Foundation, in version 2 as it comes in the "COPYING" file of the
13# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
14# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16
17LC_ALL=C
18export LC_ALL
19
20# append some extra paths
21PATH="$PATH:/opt/gnome/bin"
22# Solaris (order of paths important for tr, grep, sed to work)
23PATH="/usr/xpg4/bin:$PATH:/usr/local/bin:/usr/sfw/bin:/usr/ccs/bin"
24ORGPATH=$PATH
25
26# Wrapper for ancient /usr/bin/which on darwin that always returns 0
27which_wrapper()
28{
29 if [ -z "$have_ancient_which" ]; then
30 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
31 have_ancient_which="yes"
32 else
33 have_ancient_which="no"
34 fi
35 fi
36 if [ "$have_ancient_which" = "yes" ]; then
37 retval=`which $* 2>/dev/null`
38 echo "$retval"
39 test -n "$retval" -a -x "$retval"
40 unset retval
41 else
42 which $* 2> /dev/null
43 fi
44}
45
46OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr '[:upper:]' '[:lower:]'`
47case "$OS" in
48 linux)
49 ;;
50 darwin)
51 ;;
52 freebsd)
53 ;;
54 netbsd)
55 ;;
56 sunos)
57 OS='solaris'
58 ;;
59 haiku)
60 ;;
61 *)
62 echo "Cannot determine OS!"
63 exit 1
64 ;;
65esac
66
67#
68# Defaults
69#
70OSE=1
71ODIR="`pwd`/"
72ODIR_OVERRIDE=0
73OUT_PATH=""
74OUT_PATH_OVERRIDE=0
75SETUP_WINE=
76ONLY_ADDITIONS=0
77TARGET_MACHINE=""
78TARGET_CPU=""
79WITH_XPCOM=1
80WITH_PYTHON=1
81WITH_JAVA=1
82WITH_VMMRAW=1
83WITH_LIBIDL=1
84WITH_GSOAP=0
85WITH_QT5=1
86WITH_SDL=1
87WITH_SDL_TTF=1
88WITH_X11=1
89WITH_ALSA=1
90WITH_PULSE=1
91WITH_DBUS=1
92WITH_DEVMAPPER=1
93WITH_KMODS=1
94WITH_OPENGL=1
95WITH_HARDENING=1
96WITH_UDPTUNNEL=1
97WITH_VDE=0
98WITH_VNC=0
99WITH_EXTPACK=1
100WITH_DOCS=1
101WITH_LIBVPX=1
102WITH_LIBOPUS=1
103BUILD_LIBXML2=
104BUILD_LIBCURL=
105BUILD_LIBSSL=
106BUILD_LIBVPX=
107PASSIVE_MESA=0
108CC="gcc"
109CC32=""
110CC64=""
111CXX="g++"
112CXX32=""
113CXX64=""
114YASM="yasm"
115IASL="iasl"
116XSLTPROC="xsltproc"
117GENISOIMAGE="genisoimage"
118INCCRYPTO=""
119LIBCRYPTO="-lssl -lcrypto"
120LIBPTHREAD="-lpthread"
121LIBCAP="-lcap"
122GSOAP=""
123GSOAP_IMPORT=""
124INCX11="/usr/local/include"
125LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -L/usr/local/lib -lXext -lX11"
126LIBXCURSOR="-lXcursor"
127LIBXMU="-lXmu"
128LIBXINERAMA="-lXinerama"
129LIBXRANDR="-lXrandr"
130MAKESELF="makeself"
131MESA="-lGL"
132INCZ=""
133LIBZ="-lz"
134INCVNCSERVER=""
135LIBVNCSERVER="-lvncserver"
136INCDEVMAPPER=""
137LIBDEVMAPPER="-ldevmapper"
138CXX_FLAGS=""
139if [ "$OS" = "freebsd" ]; then
140 INCCURL="-I/usr/local/include"
141 LIBCURL="-L/usr/local/lib -lcurl"
142 INCPULSE="-I/usr/local/include"
143 LIBPULSE="-L/usr/local/lib"
144 INCPNG="-I/usr/local/include"
145 LIBPNG="-L/usr/local/lib -lpng"
146else
147 INCCURL=""
148 LIBCURL="-lcurl"
149 INCPNG=""
150 LIBPNG="-lpng"
151fi
152INCVPX=""
153LIBVPX="-lvpx"
154PKGCONFIG="`which_wrapper pkg-config`"
155PYTHONDIR="/usr /usr/local"
156QT5DIR="/usr/lib/qt5 /usr/share/qt5 /usr/lib64/qt5 /usr /usr/local"
157QT5DIR_PKGCONFIG=1
158QT5MAJ=5
159QT5MIN=6
160KBUILDDIR="`cd \`dirname $0\`; pwd`/kBuild"
161DEVDIR="`cd \`dirname $0\`; pwd`/tools"
162if [ -d "/lib/modules/`uname -r`/build" ]; then
163 LINUX="/lib/modules/`uname -r`/build"
164elif [ "`echo /lib/modules/*`" != "/lib/modules/*" ]; then
165 # Get the most recent kernel headers if none match the current kernel.
166 for i in /lib/modules/*; do
167 if [ -r "$i/build" ]; then
168 LINUX="$i/build"
169 fi
170 done
171fi
172if [ -z "$LINUX" ]; then
173 LINUX="/usr/src/linux"
174fi
175KCHMVIEWER="kchmviewer"
176LOG="configure.log"
177CNF="AutoConfig.kmk"
178ENV="env.sh"
179BUILD_TYPE="release"
180# the restricting tool is ar (mri mode).
181INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
182
183if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
184 echo "Error: VBox base path contains invalid characters!"
185 exit 1
186fi
187
188# Posix /bin/sh isn't supporting echo -n. Use printf instead.
189ECHO_N="printf"
190
191
192cleanup()
193{
194 rm -f $ODIR.tmp_src.cc $ODIR.tmp_src.c $ODIR.tmp_out $ODIR.test_execute.log
195}
196
197fail()
198{
199 if [ -z "$nofatal" -o "x$1" != "x" ]; then
200 cleanup
201 rm -f $ENV
202 echo "Check $LOG for details"
203 exit 1
204 fi
205}
206
207log()
208{
209 echo "$1"
210 echo "$1" >> $LOG
211}
212
213log_success()
214{
215 if [ -n "$1" ]; then $ECHO_N "$1, "; fi
216 echo "OK."
217 echo "$1" >> $LOG
218 echo >> $LOG
219 echo >> $LOG
220}
221
222log_failure()
223{
224 echo
225 echo " ** $1!"
226 echo "** $1!" >> $LOG
227 echo >> $LOG
228}
229
230cnf_append()
231{
232 printf "%-30s := %s\n" "$1" "$2" >> $CNF
233}
234
235strip_l()
236{
237 echo "$1"|$KBUILD_SED 's|-l\([^ ]\+\)|\1|g; s|^-[^l][^ ]*||g; s| -[^l][^ ]*||g; s|^ ||; s| *$||g'
238}
239
240strip_L()
241{
242 echo "$1"|$KBUILD_SED 's|-L\([^ ]\+\)|\1|g; s|^-[^L][^ ]*||g; s| -[^L][^ ]*||g; s|^ ||; s| *$||g'
243}
244
245strip_I()
246{
247 echo "$1"|$KBUILD_SED 's|-I\([^ ]\+\)|\1|g; s|^-[^I][^ ]*||g; s| -[^I][^ ]*||g; s|^ ||; s| *$||g'
248}
249
250prefix_I()
251{
252 echo "$1"|$KBUILD_SED 's|^\/|-I/|g; s| \/| -I/|g'
253}
254
255check_avail()
256{
257 if [ -z "$1" ]; then
258 log_failure "$2 is empty"
259 fail $3
260 return 1
261 elif which_wrapper $1 > /dev/null; then
262 return 0
263 else
264 log_failure "$1 (variable $2) not found"
265 fail $3
266 return 1
267 fi
268}
269
270
271# Prepare a test
272test_header()
273{
274 echo "***** Checking $1 *****" >> $LOG
275 $ECHO_N "Checking for $1: "
276}
277
278
279# Compile a test
280# $1 compile flags/libs
281# $2 library name
282# $3 package name
283# $4 if this argument is 'nofatal', don't abort
284test_compile()
285{
286 echo "compiling the following source file:" >> $LOG
287 cat $ODIR.tmp_src.cc >> $LOG
288 echo "using the following command line:" >> $LOG
289 echo "$CXX $CXX_FLAGS -fPIC -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc \"$1\"" >> $LOG
290 $CXX $CXX_FLAGS -fPIC -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc $1 >> $LOG 2>&1
291 if [ $? -ne 0 ]; then
292 if [ -z "$4" ]; then
293 echo
294 echo " $2 not found at $1 or $3 headers not found"
295 echo " Check the file $LOG for detailed error information."
296 fail
297 else
298 echo >> $LOG
299 echo >> $LOG
300 fi
301 return 1
302 fi
303 return 0
304}
305
306
307# Execute a compiled test binary
308test_execute()
309{
310 echo "executing the binary" >> $LOG
311 $ODIR.tmp_out > $ODIR.test_execute.log
312 rc=$?
313 cat $ODIR.test_execute.log | tee -a $LOG
314 if [ $rc -ne 0 ]; then
315 fail $1
316 return 1
317 fi
318 echo >> $LOG
319 echo >> $LOG
320 return 0
321}
322
323
324# Execute a compiled test binary
325test_execute_path()
326{
327 ## LD_LIBRARY_PATH to set.
328 local_path="${1}"
329 ## Set this to non-empty to make this test non-fatal.
330 local_nofail="${2}"
331 echo "executing the binary (LD_LIBRARY_PATH=$1)" >> $LOG
332 LD_LIBRARY_PATH="${local_path}" $ODIR.tmp_out > $ODIR.test_execute.log
333 rc=$?
334 cat $ODIR.test_execute.log | tee -a $LOG
335 if [ $rc -ne 0 ]; then
336 test -z "${local_nofail}" && fail
337 echo >> $LOG
338 echo >> $LOG
339 return 1
340 fi
341 echo >> $LOG
342 echo >> $LOG
343 return 0
344}
345
346
347#
348# Check for OS, MACHINE, CPU
349#
350check_environment()
351{
352 test_header environment
353 BUILD_CPU=`uname -m`
354 [ "$OS" = "solaris" ] && BUILD_CPU=`isainfo | cut -f 1 -d ' '`
355 case "$BUILD_CPU" in
356 i[3456789]86|x86|i86pc|BePC)
357 BUILD_MACHINE='x86'
358 LIB='lib'
359 ;;
360 x86_64|amd64)
361 BUILD_MACHINE='amd64'
362 BUILD_CPU='k8'
363 if [ "$OS" != "solaris" ]; then
364 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
365 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
366 LIB='lib64'
367 else
368 # Solaris doesn't seem to subscribe to fhs, libs are usually in
369 # a '64' subdirectory of the standard 'lib' dirs while some 64-bit
370 # alternative binaries can be found in 'amd64' subdirs of the 'bin'
371 # ones. So, in order to find the right stuff (esp. sdl-config) we'll
372 # have to make sure the */bin/amd64 dirs are searched before the */bin
373 # ones. (The sed has some sideeffects, but they shouldn't harm us...)
374 echo "64-bit Solaris detected, hacking the PATH" >> $LOG
375 echo "old PATH: $PATH" >> $LOG
376 PATH=`echo ":$PATH:" | sed -e 's,\(:[^:]*/bin\):,\1/amd64:\1:,g' \
377 -e 's/^:*//' -e 's/:*$//g' -e 's/::*/:/g' `
378 export PATH
379 echo "new PATH: $PATH" >> $LOG
380 LIB='lib/64'
381 fi
382 ;;
383 sparc64|sparcv9)
384 BUILD_MACHINE='sparc64'
385 BUILD_CPU='blend'
386 ;;
387 sparc32|sparc|sparcv8|sparcv7|sparcv8e)
388 BUILD_MACHINE='sparc32'
389 BUILD_CPU='blend'
390 ;;
391 *)
392 log_failure "Cannot determine system"
393 exit 1
394 ;;
395 esac
396 [ -z "$TARGET_MACHINE" ] && TARGET_MACHINE=$BUILD_MACHINE
397 [ -z "$TARGET_CPU" ] && TARGET_CPU=$BUILD_CPU
398 DEVDIR_BIN="$DEVDIR/$OS.$BUILD_MACHINE/bin"
399 log_success "Determined build machine: $OS.$BUILD_MACHINE, target machine: $OS.$TARGET_MACHINE"
400
401 echo "BUILD_PLATFORM=\"$OS\"" >> $ENV
402 echo "export BUILD_PLATFORM" >> $ENV
403 echo "BUILD_PLATFORM_ARCH=\"$BUILD_MACHINE\"" >> $ENV
404 echo "export BUILD_PLATFORM_ARCH" >> $ENV
405 echo "BUILD_TARGET=\"$OS\"" >> $ENV
406 echo "export BUILD_TARGET" >> $ENV
407 echo "BUILD_TARGET_ARCH=\"$TARGET_MACHINE\"" >> $ENV
408 echo "export BUILD_TARGET_ARCH" >> $ENV
409 echo "BUILD_TARGET_CPU=\"$TARGET_CPU\"" >> $ENV
410 echo "export BUILD_TARGET_CPU" >> $ENV
411 echo "BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
412 echo "export BUILD_TYPE" >> $ENV
413}
414
415#
416# Check for gcc with version >= 3.2.
417# We depend on a working gcc, if we fail terminate in every case.
418#
419check_gcc()
420{
421 test_header gcc
422 if check_avail "$CC" CC really; then
423 cc_ver=`$CC -dumpfullversion 2>/dev/null`
424 if [ $? -ne 0 ]; then
425 cc_ver=`$CC -dumpversion 2>/dev/null`
426 fi
427 if [ $? -ne 0 ]; then
428 log_failure "cannot execute '$CC -dumpversion'"
429 fail really
430 fi
431 if check_avail "$CXX" CXX really; then
432 cxx_ver=`$CXX -dumpfullversion 2>/dev/null`
433 if [ $? -ne 0 ]; then
434 cxx_ver=`$CXX -dumpversion 2>/dev/null`
435 fi
436 if [ $? -ne 0 ]; then
437 log_failure "cannot execute '$CXX -dumpversion'"
438 fail really
439 fi
440 cc_maj=`echo $cc_ver|cut -d. -f1`
441 cc_min=`echo $cc_ver|cut -d. -f2`
442 if [ "x$cc_ver" != "x$cxx_ver" ]; then
443 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
444 fail really
445 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 -a "$OS" = "darwin" ]; then
446 log_success "found version $cc_ver"
447 # gcc-4.0 is allowed for Darwin only
448 elif [ $cc_maj -eq 4 -a $cc_min -eq 2 -a "$OS" = "freebsd" ]; then
449 log_success "found version $cc_ver"
450 # gcc-4.2 is allowed for FreeBSD only
451 elif [ $cc_maj -lt 4 \
452 -o \( $cc_maj -eq 4 -a $cc_min -lt 4 -a "$OS" != "darwin" \) \
453 -o \( $cc_maj -eq 4 -a $cc_min -lt 2 -a "$OS" = "darwin" \) ]; then
454 log_failure "gcc version $cc_maj.$cc_min found, expected gcc 4.x or later"
455 fail really
456 else
457 log_success "found version $cc_ver"
458 fi
459 if [ "$BUILD_MACHINE" = "amd64" ]; then
460 [ -z "$CC32" ] && CC32="$CC -m32"
461 [ -z "$CXX32" ] && CXX32="$CXX -m32"
462 else
463 [ -z "$CC32" ] && CC32="$CC"
464 [ -z "$CXX32" ] && CXX32="$CXX"
465 fi
466 if [ "$BUILD_MACHINE" = "x86" -a "$TARGET_MACHINE" = "amd64" ]; then
467 [ -z "$CC64" ] && CC64="$CC -m64"
468 [ -z "$CXX64" ] && CXX64="$CXX -m64"
469 fi
470 if [ "$TARGET_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 0 ]; then
471 CC32="undefined"
472 CXX32="undefined"
473 fi
474 if [ "$CC" != "gcc" ]; then
475 cnf_append "TOOL_GCC3_CC" "$CC"
476 cnf_append "TOOL_GCC3_AS" "$CC"
477 cnf_append "TOOL_GCC3_LD" "$CC"
478 cnf_append "TOOL_GXX3_CC" "$CC"
479 cnf_append "TOOL_GXX3_AS" "$CC"
480 fi
481 if [ "$CXX" != "g++" ]; then
482 cnf_append "TOOL_GCC3_CXX" "$CXX"
483 cnf_append "TOOL_GXX3_CXX" "$CXX"
484 cnf_append "TOOL_GXX3_LD" "$CXX"
485 fi
486 if [ "$CC32" != "gcc -m32" -a "$CC32" != "undefined" ]; then
487 cnf_append "TOOL_GCC32_CC" "$CC32"
488 cnf_append "TOOL_GCC32_AS" "$CC32"
489 cnf_append "TOOL_GCC32_LD" "$CC32"
490 cnf_append "TOOL_GXX32_CC" "$CC32"
491 cnf_append "TOOL_GXX32_AS" "$CC32"
492 fi
493 if [ "$CXX32" != "g++ -m32" -a "$CXX32" != "undefined" ]; then
494 cnf_append "TOOL_GCC32_CXX" "$CXX32"
495 cnf_append "TOOL_GXX32_CXX" "$CXX32"
496 cnf_append "TOOL_GXX32_LD" "$CXX32"
497 fi
498 # this isn't not necessary, there is not such tool.
499 if [ -n "$CC64" ]; then
500 cnf_append "TOOL_GCC64_CC" "$CC64"
501 cnf_append "TOOL_GCC64_AS" "$CC64"
502 cnf_append "TOOL_GCC64_LD" "$CC64"
503 cnf_append "TOOL_GXX64_CC" "$CC64"
504 cnf_append "TOOL_GXX64_AS" "$CC64"
505 fi
506 if [ -n "$CXX64" ]; then
507 cnf_append "TOOL_GCC64_CXX" "$CXX64"
508 cnf_append "TOOL_GXX64_CXX" "$CXX64"
509 cnf_append "TOOL_GXX64_LD" "$CXX64"
510 fi
511 if [ "$CC" != "gcc" ]; then
512 if [ -n "$CC64" ]; then
513 cnf_append "TOOL_Bs3Gcc64Elf64_CC" "$CC64"
514 else
515 cnf_append "TOOL_Bs3Gcc64Elf64_CC" "$CC"
516 fi
517 if [ -n "$CXX64" ]; then
518 cnf_append "TOOL_Bs3Gcc64Elf64_CXX" "$CXX64"
519 else
520 cnf_append "TOOL_Bs3Gcc64Elf64_CXX" "$CXX"
521 fi
522 fi
523 # Solaris sports a 32-bit gcc/g++.
524 if [ "$OS" = "solaris" -a "$BUILD_MACHINE" = "amd64" ]; then
525 [ "$CC" = "gcc" ] && CC="gcc -m64"
526 [ "$CXX" = "g++" ] && CXX="g++ -m64"
527 fi
528 fi
529 fi
530}
531
532
533#
534# Check for the OpenWatcom compiler, needed for compiling the BIOS
535#
536# If the system has Open Watcom installed, WATCOM will be set in the
537# environment. If the user has her/his own Open Watcom install it will be
538# pointed to by on the command line, which will set the WATCOM variable.
539# The only exception is detecting OpenWatcom in tools/common/openwatcom.
540#
541check_open_watcom()
542{
543 test_header "Open Watcom"
544
545 if [ -z "$WATCOM" ]; then
546 WATCOM=`/bin/ls -rd1 $PWD/tools/common/openwatcom/* 2> /dev/null | head -1`
547 if [ -z "$WATCOM" ]; then
548 if [ $OSE -eq 0 -a $OS = "linux" ]; then
549 log_failure "Open Watcom was not found"
550 exit 1
551 fi
552 log_failure "Open Watcom was not found, using alternative BIOS sources"
553 cnf_append "VBOX_WITH_OPEN_WATCOM" ""
554 return 0;
555 fi
556 fi
557
558 case "$OS" in
559 "darwin") wc_bin="binosx";; # ??
560 "dos") wc_bin="binw";;
561 "freebsd") wc_bin="binfbsd";; # ??
562 "linux") wc_bin="binl";;
563 "netbsd") wc_bin="binnbsd";; # ??
564 "solaris") wc_bin="binsol";; # ??
565 "os2") wc_bin="binp";;
566 "win") wc_bin="binnt";;
567 *) wc_bin="binl";;
568 esac
569
570 # Check that the tools we use are there.
571 for prog in wasm wcc wlink;
572 do
573 if [ ! -f "$WATCOM/$wc_bin/$prog" ]; then
574 log_failure "$WATCOM/$wc_bin/$prog does not exist or is not a regular file."
575 fail
576 fi
577 done
578
579 # Use WASM to get the version.
580 wasm_ver=`$WATCOM/$wc_bin/wasm -? 2>&1 | sed -e '1!d' -e 's/Open Watcom Assembler Version *//'`
581 if [ -z "$wasm_ver" ]; then
582 log_failure "$WATCOM/$wc_bin/wasm -? did not produce the expected response"
583 fail
584 fi
585 log_success "found version $wasm_ver"
586 cnf_append "PATH_TOOL_OPENWATCOM" "$WATCOM"
587 cnf_append "VBOX_WITH_OPEN_WATCOM" "1"
588
589 unset wasm_ver
590 unset wc_wasm
591 unset wc_bin
592}
593
594
595#
596# Check for yasm, needed to compile assembler files
597#
598check_yasm()
599{
600 test_header yasm
601 if check_avail "$YASM" YASM; then
602 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
603 if [ $? -ne 0 ]; then
604 log_failure "yasm not found"
605 fail
606 else
607 yasm_maj=`echo $yasm_ver|cut -d. -f1`
608 yasm_min=`echo $yasm_ver|cut -d. -f2`
609 yasm_rev=`echo $yasm_ver|cut -d. -f3`
610 yasm_ver_mul=`expr $yasm_maj \* 10000 + $yasm_min \* 100 + $yasm_rev`
611 if [ $yasm_ver_mul -lt 501 ]; then
612 log_failure "found version $yasm_ver, expected at least 0.5.1"
613 fail
614 else
615 log_success "found version $yasm_ver"
616 fi
617 fi
618 fi
619}
620
621
622#
623# Check for the iasl ACPI compiler, needed to compile vbox.dsl
624#
625check_iasl()
626{
627 test_header iasl
628 if check_avail "$IASL" IASL; then
629 iasl_ver=`$IASL|grep "ASL.*version"|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
630 if [ $? -ne 0 ]; then
631 log_failure "iasl not found"
632 fail
633 else
634 log_success "found version $iasl_ver"
635 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
636 fi
637 fi
638}
639
640
641#
642# Check for xsltproc, needed by Main
643#
644check_xsltproc()
645{
646 if [ -n "$BUILD_LIBXSLT" ]; then
647 return 0;
648 fi
649 test_header xslt
650 if check_avail "$XSLTPROC" XSLTPROC; then
651 xsltproc_ver=`$XSLTPROC --version`
652 if [ $? -ne 0 ]; then
653 log_failure "xsltproc not found"
654 fail
655 else
656 log_success "found"
657 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
658 fi
659 fi
660}
661
662
663#
664# Check for libxml2, needed by the Runtime.
665# 2.6.24 is known to NOT work, 2.6.26 is known to work (there is no 2.6.25 release)
666#
667check_libxml2()
668{
669 if [ -z "$BUILD_LIBXML2" ]; then
670 test_header libxml2
671 if which_wrapper pkg-config > /dev/null; then
672 libxml2_ver=`pkg-config libxml-2.0 --modversion 2>> $LOG`
673 if [ $? -ne 0 ]; then
674 log_failure "libxml2 not found"
675 fail
676 else
677 FLGXML2=`pkg-config libxml-2.0 --cflags`
678 INCXML2=`strip_I "$FLGXML2"`
679 LIBXML2=`pkg-config libxml-2.0 --libs`
680 cat > $ODIR.tmp_src.cc << EOF
681#include <cstdio>
682#include <libxml/xmlversion.h>
683extern "C" int main(void)
684{
685 printf("found version %s", LIBXML_DOTTED_VERSION);
686#if LIBXML_VERSION >= 20626
687 printf(", OK.\n");
688 return 0;
689#else
690 printf(", expected version 2.6.26 or higher\n");
691 return 1;
692#endif
693}
694EOF
695 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
696 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
697 if test_execute; then
698 cnf_append "SDK_VBOX_LIBXML2_DEFS" "_REENTRANT" ## @todo get defines from --cflags
699 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
700 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
701 fi
702 fi
703 fi
704 elif which_wrapper xml2-config; then
705 libxml2_ver=`xml2-config --version`
706 if [ $? -ne 0 ]; then
707 log_failure "xml2-config not found"
708 fail
709 else
710 log_success "found version $libxml2_ver"
711 FLGXML2=`xml2-config --cflags`
712 INCXML2=`strip_I "$FLGXML2"`
713 LIBXML2=`xml2-config --libs`
714 cat > $ODIR.tmp_src.cc << EOF
715#include <cstdio>
716#include <libxml/xmlversion.h>
717extern "C" int main(void)
718{
719 printf("found version %s", LIBXML_DOTTED_VERSION);
720#if LIBXML_VERSION >= 20626
721 printf(", OK.\n");
722 return 0;
723#else
724 printf(", expected version 2.6.26 or higher\n");
725 return 1;
726#endif
727}
728EOF
729 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
730 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
731 if test_execute; then
732 cnf_append "SDK_VBOX_LIBXML2_DEFS" "_REENTRANT" ## @todo get defines from --cflags
733 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
734 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
735 fi
736 fi
737 fi
738 else
739 log_failure "neither pkg-config nor xml2-config found"
740 fail
741 fi
742 fi
743}
744
745
746#
747# Check for libIDL, needed by xpcom
748#
749check_libidl()
750{
751 test_header libIDL
752
753 if which_wrapper libIDL-config-2 > /dev/null; then
754 libidl_ver=`libIDL-config-2 --version`
755 if [ $? -ne 0 ]; then
756 log_failure "libIDL-config-2 not working"
757 fail
758 else
759 log_success "found version $libidl_ver"
760 cnf_append "VBOX_LIBIDL_CONFIG" \
761 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
762 fi
763 elif check_avail "libIDL-config" libIDL-config; then
764 libidl_ver=`libIDL-config --version`
765 if [ $? -ne 0 ]; then
766 log_failure "libIDL-config not working"
767 fail
768 else
769 log_success "found version $libidl_ver"
770 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
771 fi
772 fi
773}
774
775
776#
777# Check for libdevmapper, needed by the VBoxVolInfo
778#
779check_libdevmapper()
780{
781 test_header libdevmapper
782 cat > $ODIR.tmp_src.cc << EOF
783#include <cstdio>
784extern "C" {
785#define private
786#include <libdevmapper.h>
787int main()
788{
789 char version[80];
790
791 if (!dm_get_library_version(version, sizeof(version)))
792 {
793 printf("dm_get_library_version() failed.\n");
794 return 1;
795 }
796
797 const char* v=version;
798 unsigned int major = 0, minor = 0, micro = 0;
799
800 for (; *v !='.' && *v != '\0'; v++) major = major*10 + *v-'0';
801 if (*v == '.') v++;
802 for (; *v !='.' && *v != '\0'; v++) minor = minor*10 + *v-'0';
803 if (*v == '.') v++;
804 for (; *v !='.' && *v != '\0'; v++) micro = micro*10 + *v-'0';
805
806 printf("found version %s", version);
807 if (major*10000 + minor*100 + micro >= 10200)
808 {
809 printf(", OK.\n");
810 return 0;
811 }
812 else
813 {
814 printf(", expected version 1.02 or higher\n");
815 return 1;
816 }
817}
818}
819EOF
820 if test_compile "$LIBDEVMAPPER $INCDEVMAPPER" libdevmapper libdevmapper; then
821 if test_execute; then
822 cnf_append "VBOX_WITH_DEVMAPPER" "1"
823 fi
824 fi
825}
826
827
828#
829# Check for openssl, needed for RDP and S3
830#
831check_ssl()
832{
833 if [ -z "$BUILD_LIBSSL" ]; then
834 test_header ssl
835 cat > $ODIR.tmp_src.cc << EOF
836#include <cstdio>
837#include <openssl/opensslv.h>
838#include <openssl/ssl.h>
839extern "C" int main(void)
840{
841 printf("found version %s", OPENSSL_VERSION_TEXT);
842 SSL_library_init();
843#if OPENSSL_VERSION_NUMBER >= 0x10001000
844 printf(", OK.\n");
845 return 0;
846#else
847 printf(", expected version 1.0.1 or higher\n");
848 return 1;
849#endif
850}
851EOF
852 if test_compile "$INCCRYPTO $LIBCRYPTO" libcrypto openssl; then
853 if test_execute nofatal; then
854 cnf_append "SDK_VBOX_OPENSSL_INCS" "`strip_I "$INCCRYPTO"`"
855 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
856 cnf_append "SDK_VBOX_BLD_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
857 fi
858 fi
859 fi
860}
861
862
863#
864# Check for pthread, needed by VBoxSVC, frontends, ...
865#
866check_pthread()
867{
868 test_header pthread
869 cat > $ODIR.tmp_src.cc << EOF
870#include <cstdio>
871#include <pthread.h>
872extern "C" int main(void)
873{
874 pthread_mutex_t mutex;
875 if (pthread_mutex_init(&mutex, NULL)) {
876 printf("pthread_mutex_init() failed\n");
877 return 1;
878 }
879 if (pthread_mutex_lock(&mutex)) {
880 printf("pthread_mutex_lock() failed\n");
881 return 1;
882 }
883 if (pthread_mutex_unlock(&mutex)) {
884 printf("pthread_mutex_unlock() failed\n");
885 return 1;
886 }
887 printf("found, OK.\n");
888}
889EOF
890 if test_compile $LIBPTHREAD pthread pthread; then
891 if test_execute; then
892 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
893 fi
894 fi
895}
896
897
898#
899# Check for zlib, needed by VBoxSVC, Runtime, ...
900#
901check_z()
902{
903 test_header zlib
904 cat > $ODIR.tmp_src.cc << EOF
905#include <cstdio>
906#include <zlib.h>
907extern "C" int main(void)
908{
909 printf("found version %s", ZLIB_VERSION);
910#if ZLIB_VERNUM >= 0x1210
911 printf(", OK.\n");
912 return 0;
913#else
914 printf(", expected version 1.2.1 or higher\n");
915 return 1;
916#endif
917}
918EOF
919 [ -n "$INCZ" ] && I_INCZ=`prefix_I "$INCZ"`
920 if test_compile "$LIBZ $I_INCZ" zlib zlib; then
921 if test_execute; then
922 echo "if1of (\$(KBUILD_TARGET),darwin freebsd haiku linux)" >> $CNF
923 cnf_append " SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
924 cnf_append " SDK_VBOX_ZLIB_INCS" "$INCZ"
925 echo "endif" >> $CNF
926 fi
927 fi
928}
929
930
931#
932# Check for libpng, needed by kchmviewer
933#
934check_png()
935{
936 test_header libpng
937 cat > $ODIR.tmp_src.cc << EOF
938#include <cstdio>
939#include <png.h>
940extern "C" int main(void)
941{
942 printf("found version %s", PNG_LIBPNG_VER_STRING);
943#if PNG_LIBPNG_VER >= 10205
944 printf(", OK.\n");
945 return 0;
946#else
947 printf(", expected version 1.2.5 or higher\n");
948 return 1;
949#endif
950}
951EOF
952 [ -n "$INCPNG" ] && I_INCPNG=`prefix_I "$INCPNG"`
953 if test_compile "$LIBPNG $I_INCPNG" libpng libpng; then
954 if test_execute; then
955 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
956 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
957 fi
958 fi
959}
960
961#
962# Check for libvncserver, needed for VNC in OSE
963#
964check_vncserver()
965{
966 test_header libvncserver
967 cat > $ODIR.tmp_src.cc <<EOF
968#include <cstdio>
969#include <rfb/rfbconfig.h>
970
971extern "C" int main()
972{
973 const char* v=LIBVNCSERVER_VERSION;
974 unsigned int major = 0, minor = 0, micro = 0;
975
976 for (; *v !='.' && *v != '\0'; v++) major = major*10 + *v-'0';
977 if (*v == '.') v++;
978 for (; *v !='.' && *v != '\0'; v++) minor = minor*10 + *v-'0';
979 if (*v == '.') v++;
980 for (; *v !='.' && *v != '\0'; v++) micro = micro*10 + *v-'0';
981
982 printf("found version %s", LIBVNCSERVER_PACKAGE_VERSION);
983 if (major*10000 + minor*100 + micro >= 900)
984 {
985 printf(", OK.\n");
986 return 0;
987 }
988 else
989 {
990 printf(", expected version 0.9 or higher\n");
991 return 1;
992 }
993}
994EOF
995 if test_compile "$LIBVNCSERVER $INCVNCSERVER" libvncserver libvncserver; then
996 if test_execute; then
997 cnf_append "VBOX_WITH_EXTPACK_VNC" "1"
998 fi
999 fi
1000}
1001
1002#
1003# Check for libcurl, needed by S3
1004#
1005check_curl()
1006{
1007 if [ -z "$BUILD_LIBCURL" ]; then
1008 test_header libcurl
1009 cat > $ODIR.tmp_src.cc << EOF
1010#include <cstdio>
1011#include <curl/curl.h>
1012extern "C" int main(void)
1013{
1014 printf("found version %s", LIBCURL_VERSION);
1015#if 10000*LIBCURL_VERSION_MAJOR + 100*LIBCURL_VERSION_MINOR + LIBCURL_VERSION_PATCH >= 71901
1016 printf(", OK.\n");
1017 return 0;
1018#else
1019 printf(", expected version 7.19.1 or higher\n");
1020 return 1;
1021#endif
1022}
1023EOF
1024 [ -n "$INCCURL" ] && I_INCCURL=`prefix_I "$INCCURL"`
1025 if test_compile "$LIBCURL $I_INCCURL" libcurl libcurl; then
1026 if test_execute; then
1027 cnf_append "SDK_VBOX_LIBCURL_LIBS" "`strip_l "$LIBCURL"`"
1028 cnf_append "SDK_VBOX_LIBCURL_INCS" "$INCCURL"
1029 fi
1030 fi
1031 fi
1032}
1033
1034
1035#
1036# Check for pam, needed by VRDPAuth
1037# Version 79 was introduced in 9/2005, do we support older versions?
1038# Debian/sarge uses 76
1039# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
1040#
1041check_pam()
1042{
1043 test_header pam
1044 cat > $ODIR.tmp_src.cc << EOF
1045#include <cstdio>
1046#include <security/pam_appl.h>
1047extern "C" int main(void)
1048{
1049 printf("found version %d", __LIBPAM_VERSION);
1050 if (__LIBPAM_VERSION >= 76)
1051 {
1052 printf(", OK.\n");
1053 return 0;
1054 }
1055 else
1056 {
1057 printf(", expected version 76 or higher\n");
1058 return 1;
1059 }
1060}
1061EOF
1062 if test_compile "-lpam" pam pam nofatal; then
1063 if test_execute nofatal; then
1064 return 0;
1065 fi
1066 fi
1067 echo "pam0.x not found"
1068 test_header linux_pam
1069 cat > $ODIR.tmp_src.cc << EOF
1070#include <cstdio>
1071#include <security/pam_appl.h>
1072extern "C" int main(void)
1073{
1074 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
1075 if (__LINUX_PAM__ >= 1)
1076 {
1077 printf(", OK.\n");
1078 return 0;
1079 }
1080 else
1081 {
1082 printf(", expected version 1.0 or higher\n");
1083 return 1;
1084 }
1085}
1086EOF
1087 if test_compile "-lpam" pam pam; then
1088 test_execute
1089 fi
1090}
1091
1092
1093#
1094# Check for the SDL library, needed by VBoxSDL and VirtualBox
1095# We depend at least on version 1.2.7
1096#
1097check_sdl()
1098{
1099 test_header SDL
1100 if [ "$OS" = "darwin" ]; then
1101 if [ -f "/System/Library/Frameworks/SDL.framework/SDL" ]; then
1102 PATH_SDK_LIBSDL="/System/Library/Frameworks/SDL.framework"
1103 elif [ -f "/Library/Frameworks/SDL.framework/SDL" ]; then
1104 PATH_SDK_LIBSDL="/Library/Frameworks/SDL.framework"
1105 fi
1106 if [ -n "$PATH_SDK_LIBSDL" ]; then
1107 foundsdl=1
1108 INCSDL="$PATH_SDK_LIBSDL/Headers"
1109 FLDSDL="-framework SDL"
1110 else
1111 log_failure "SDL framework not found"
1112 fail
1113 fi
1114 else
1115 if which_wrapper sdl-config > /dev/null; then
1116 FLGSDL=`sdl-config --cflags`
1117 INCSDL=`strip_I "$FLGSDL"`
1118 LIBSDL=`sdl-config --libs`
1119 LIBSDLMAIN="-lSDLmain"
1120 FLDSDL=
1121 foundsdl=1
1122 fi
1123 fi
1124 [ "$OS" = "linux" -o "$OS" = "darwin" -o "$OS" = "solaris" ] && LIBSDLMAIN=""
1125 if [ -n "$foundsdl" ]; then
1126 cat > $ODIR.tmp_src.cc << EOF
1127#include <cstdio>
1128#include <SDL.h>
1129#include <SDL_main.h>
1130#undef main
1131extern "C" int main(int argc, char** argv)
1132{
1133 printf("found version %d.%d.%d",
1134 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
1135#if SDL_VERSION_ATLEAST(1,2,7)
1136 printf(", OK.\n");
1137 return 0;
1138#else
1139 printf(", expected version 1.2.7 or higher\n");
1140 return 1;
1141#endif
1142}
1143EOF
1144 [ -n "$INCSDL" ] && I_INCSDL=`prefix_I "$INCSDL"`
1145 if test_compile "$LIBSDL $LIBSDLMAIN $I_INCSDL $FLDSDL" SDL SDL; then
1146 if test_execute; then
1147 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
1148 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
1149 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
1150 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
1151 [ -n "$FLDSDL" ] && cnf_append "SDK_LIBSDL_LDFLAGS" "$FLDSDL"
1152 fi
1153 fi
1154 else
1155 log_failure "SDL not found (can be disabled using --disable-sdl)"
1156 fail
1157 fi
1158}
1159
1160
1161#
1162# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
1163#
1164check_sdl_ttf()
1165{
1166 test_header SDL_ttf
1167 cat > $ODIR.tmp_src.cc << EOF
1168#include <cstdio>
1169#include <SDL_ttf.h>
1170#ifndef SDL_TTF_MAJOR_VERSION
1171#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
1172#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
1173#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
1174#endif
1175extern "C" int main(void)
1176{
1177 printf("found version %d.%d.%d",
1178 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
1179#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
1180 printf(", OK.\n");
1181 return 0;
1182#else
1183 printf(", expected version 2.0.6 or higher\n");
1184 return 1;
1185#endif
1186}
1187EOF
1188 if test_compile "-lSDL_ttf $I_INCSDL" SDL_ttf SDL_ttf nofatal; then
1189 test_execute nofatal || \
1190 cnf_append "VBOX_WITH_SECURELABEL" ""
1191 else
1192 echo "not found -- disabling VBoxSDL secure label."
1193 cnf_append "VBOX_WITH_SECURELABEL" ""
1194 fi
1195}
1196
1197
1198#
1199# Check for libasound, needed by the ALSA audio backend
1200#
1201check_alsa()
1202{
1203 test_header ALSA
1204 cat > $ODIR.tmp_src.cc << EOF
1205#include <cstdio>
1206#include <alsa/asoundlib.h>
1207extern "C" int main(void)
1208{
1209 printf("found version %d.%d.%d",
1210 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
1211#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10014
1212 printf(", OK.\n");
1213 return 0;
1214#else
1215 printf(", expected version 1.0.14 or higher\n");
1216 return 1;
1217#endif
1218}
1219EOF
1220 if test_compile "-lasound" asound asound; then
1221 test_execute
1222 fi
1223}
1224
1225
1226#
1227# Check for PulseAudio
1228#
1229check_pulse()
1230{
1231 test_header "PulseAudio"
1232 cat > $ODIR.tmp_src.cc << EOF
1233#include <cstdio>
1234#include <pulse/version.h>
1235extern "C" int main(void)
1236{
1237 printf("found version %s API version %d", pa_get_headers_version(), PA_API_VERSION);
1238#if PA_API_VERSION >= 9
1239 printf(", OK.\n");
1240 return 0;
1241#else
1242 printf(", expected version 0.9.0 (API version 9) or higher\n");
1243 return 1;
1244#endif
1245}
1246EOF
1247 if test_compile "$INCPULSE $LIBPULSE -lpulse" pulse pulse; then
1248 test_execute
1249 fi
1250}
1251
1252
1253#
1254# Check for the X libraries (Xext, X11)
1255#
1256check_x()
1257{
1258 test_header "X libraries"
1259 cat > $ODIR.tmp_src.cc << EOF
1260#include <cstdio>
1261#include <X11/Xlib.h>
1262extern "C" int main(void)
1263{
1264 Display *dpy;
1265 int scrn_num;
1266 Screen *scrn;
1267 Window win;
1268
1269 dpy = XOpenDisplay(NULL);
1270 scrn_num = DefaultScreen(dpy);
1271 scrn = ScreenOfDisplay(dpy, scrn_num);
1272 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
1273 0, 16, InputOutput, CopyFromParent, 0, NULL);
1274 XDestroyWindow(dpy, win);
1275 XCloseDisplay(dpy);
1276}
1277EOF
1278 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1279 if test_compile "$LIBX11 $I_INCX11" Xlibs Xlibs; then
1280 log_success "found"
1281 fi
1282}
1283
1284
1285#
1286# Check for the Xcursor library, needed by VBoxSDL.
1287#
1288check_xcursor()
1289{
1290 test_header Xcursor
1291 cat > $ODIR.tmp_src.cc << EOF
1292#include <cstdio>
1293#include <X11/Xlib.h>
1294#include <X11/Xcursor/Xcursor.h>
1295extern "C" int main(void)
1296{
1297 XcursorImage *cursor = XcursorImageCreate (10, 10);
1298 XcursorImageDestroy(cursor);
1299 return 0;
1300}
1301EOF
1302 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1303 if test_compile "$LIBX11 $LIBXCURSOR $I_INCX11" Xcursor Xcursor; then
1304 log_success "found"
1305 cnf_append "VBOX_XCURSOR_LIBS" "`strip_l "$LIBXCURSOR"`"
1306 fi
1307}
1308
1309
1310#
1311# Check for the Xinerama library, needed by the Qt GUI
1312#
1313check_xinerama()
1314{
1315 test_header Xinerama
1316 cat > $ODIR.tmp_src.cc << EOF
1317#include <X11/Xlib.h>
1318#include <X11/extensions/Xinerama.h>
1319extern "C" int main(void)
1320{
1321 Display *dpy;
1322 Bool flag;
1323 dpy = XOpenDisplay(NULL);
1324 if (dpy)
1325 {
1326 flag = XineramaIsActive(dpy);
1327 XCloseDisplay(dpy);
1328 }
1329}
1330EOF
1331 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1332 if test_compile "$LIBX11 $LIBXINERAMA $I_INCX11" Xinerama Xinerama; then
1333 log_success "found"
1334 fi
1335}
1336
1337
1338#
1339# Check for the Xinerama library, needed by the Qt GUI
1340#
1341check_xrandr()
1342{
1343 test_header Xrandr
1344 cat > $ODIR.tmp_src.cc << EOF
1345#include <X11/Xlib.h>
1346#include <X11/extensions/Xrandr.h>
1347extern "C" int main(void)
1348{
1349 Display *dpy;
1350 Bool flag;
1351 int major, minor;
1352 dpy = XOpenDisplay(NULL);
1353 if (dpy)
1354 {
1355 flag = XRRQueryVersion(dpy, &major, &minor);
1356 XCloseDisplay(dpy);
1357 }
1358}
1359EOF
1360 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1361 if test_compile "$LIBX11 $LIBXRANDR $I_INCX11" Xrandr Xrandr; then
1362 log_success "found"
1363 fi
1364}
1365
1366
1367#
1368# Check for OpenGL
1369#
1370check_opengl()
1371{
1372 # On darwin this is a on/off decision only
1373 if [ "$OS" = "darwin" ]; then
1374 test_header "OpenGL support"
1375 echo "enabled"
1376 cnf_append "VBOX_WITH_CROGL" "1"
1377 else
1378 check_xmu
1379 check_mesa
1380 fi
1381}
1382
1383
1384#
1385# Check for the Xmu library, needed by OpenGL
1386#
1387check_xmu()
1388{
1389 test_header Xmu
1390 cat > $ODIR.tmp_src.cc << EOF
1391#include <cstdio>
1392#include <X11/Xatom.h>
1393#include <X11/Xlib.h>
1394#include <X11/Xutil.h>
1395#include <X11/Xmu/StdCmap.h>
1396extern "C" int main(void)
1397{
1398 Display *dpy;
1399 int scrn_num;
1400 Screen *scrn;
1401
1402 dpy = XOpenDisplay(NULL);
1403 if (dpy)
1404 {
1405 scrn_num = DefaultScreen(dpy);
1406 scrn = ScreenOfDisplay(dpy, scrn_num);
1407 Status status = XmuLookupStandardColormap(dpy, RootWindowOfScreen(scrn), 0,
1408 24, XA_RGB_DEFAULT_MAP, False, True);
1409 printf("Status = %x\n", status);
1410 XCloseDisplay(dpy);
1411 }
1412 return 0;
1413}
1414EOF
1415 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1416 if test_compile "$LIBX11 $LIBXMU $I_INCX11" Xmu Xmu; then
1417 log_success "found"
1418 cnf_append "VBOX_XMU_LIBS" "`strip_l "$LIBXMU"`"
1419 fi
1420}
1421
1422#
1423# Check for Mesa, needed by OpenGL
1424#
1425check_mesa()
1426{
1427 test_header "Mesa / GLU"
1428 cat > $ODIR.tmp_src.cc << EOF
1429#include <cstdio>
1430#include <X11/Xlib.h>
1431#include <GL/glx.h>
1432#include <GL/glu.h>
1433extern "C" int main(void)
1434{
1435 Display *dpy;
1436 int major, minor;
1437
1438 dpy = XOpenDisplay(NULL);
1439 if (dpy)
1440 {
1441 Bool glx_version = glXQueryVersion(dpy, &major, &minor);
1442 XCloseDisplay(dpy);
1443 if (glx_version)
1444 {
1445 printf("found version %u.%u, OK.\n", major, minor);
1446 return 0;
1447 }
1448 }
1449 printf("found (inactive), OK.\n");
1450 return 0;
1451}
1452EOF
1453 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1454 if test_compile "$LIBX11 $MESA $I_INCX11" Mesa Mesa; then
1455 [ $PASSIVE_MESA -eq 1 ] && unset DISPLAY
1456 test_execute
1457 fi
1458}
1459
1460
1461#
1462# Check for the Qt5 library, needed by the VirtualBox frontend
1463#
1464# Currently not fatal.
1465#
1466check_qt5()
1467{
1468 foundqt5=
1469 test_header Qt5
1470 cat > $ODIR.tmp_src.cc << EOF
1471#include <QtGlobal>
1472extern "C" int main(void)
1473{
1474EOF
1475 echo "#if QT_VERSION >= $(($QT5MAJ*65536+$QT5MIN*256))" >> $ODIR.tmp_src.cc
1476 cat >> $ODIR.tmp_src.cc << EOF
1477 return 0;
1478#else
1479 return 1;
1480#endif
1481}
1482EOF
1483 if [ "$OS" = "darwin" ]; then
1484 # First check if there is the internal version of Qt. If yes nothing else
1485 # has to be done.
1486 QT_INTERNAL=`/bin/ls -rd1 $PWD/tools/$BUILD_TARGET.$BUILD_PLATFORM_ARCH/qt/* 2> /dev/null`
1487 for t in $QT_INTERNAL; do
1488 if [ -f "$t/Frameworks/QtCoreVBox.framework/QtCoreVBox" ]; then
1489 cnf_append "VBOX_WITH_ORACLE_QT" "1"
1490 log_success "use internal version"
1491 return
1492 fi
1493 done
1494 # Now try the user provided directory and some of the standard directories.
1495 QT_TRIES="$QT5DIR /System/Library /Library"
1496 for t in $QT_TRIES; do
1497 if [ -f "$t/Frameworks/QtCore.framework/QtCore" ]; then
1498 PATH_SDK_QT5="$t"
1499 break
1500 fi
1501 done
1502 # Add the necessary params for building the test application
1503 if [ -n "$PATH_SDK_QT5" ]; then
1504 foundqt5=1
1505 INCQT5=-I$PATH_SDK_QT5/Frameworks/QtCore.framework/Headers
1506 LIBQT5=-F$PATH_SDK_QT5/Frameworks
1507 FLGQT5="-framework QtCore"
1508 else
1509 log_failure "Qt5 framework not found (can be disabled using --disable-qt)"
1510 fail
1511 fi
1512 else # !darwin
1513 if [ $QT5DIR_PKGCONFIG -eq 1 ]; then
1514 # Default is to use pkg-config:
1515 if which_wrapper pkg-config > /dev/null; then
1516 qt5_ver=`pkg-config Qt5Core --modversion 2>> $LOG`
1517 if [ $? -eq 0 ]; then
1518 echo "(Qt5 from pkg-config)" >> $LOG
1519 FLGQT5=`pkg-config Qt5Core --cflags`
1520 # gcc 4.8 is able to compile with C++11 (see also VBOX_GCC_std in Config.kmk)
1521 [ $cc_maj -eq 4 -a $cc_min -eq 8 ] && FLGQT5="$FLGQT5 -std=c++11"
1522 INCQT5=`strip_I "$FLGQT5"`
1523 LIBDIR5=`pkg-config Qt5Core --variable=libdir`
1524 LIBQT5=`pkg-config Qt5Core --libs`
1525 LIBQT5="-L$LIBDIR5 $LIBQT5"
1526 TOOLQT5=`pkg-config Qt5Core --variable=prefix`
1527 TOOLQT5BIN=`pkg-config Qt5Core --variable=host_bins`
1528 if test_compile "$LIBQT5 $LIBPTHREAD $FLGQT5" qt5 qt5 nofatal; then
1529 test_execute_path "`strip_L "$LIBQT5"`" nofatal && foundqt5=3 # pkg-config
1530 fi
1531 fi
1532 else
1533 log_failure "pkg-config not found"
1534 fail
1535 fi
1536 fi
1537 if [ -z "$foundqt5" ]; then
1538 # Do it the old way (e.g. user has specified QT5DIR):
1539 for q in $QT5DIR "$PWD/tools/linux.$TARGET_MACHINE"/qt/v5.*; do
1540 echo "(Qt5 from '$q')" >> $LOG
1541 INCQT5="$q/include $q/include/QtCore"
1542 FLGQT5="-DQT_SHARED"
1543 I_INCQT5=`prefix_I "$INCQT5"`
1544 LIBQT5="-L$q/lib -lQt5CoreVBox"
1545 TOOLQT5="$q"
1546 if test_compile "$LIBQT5 $LIBPTHREAD $I_INCQT5 $FLGQT5" qt5 qt5 nofatal &&
1547 test_execute_path "`strip_L "$LIBQT5"`" nofatal; then
1548 foundqt5=2 # internal
1549 break;
1550 fi
1551 LIBQT5="-L$q/lib -lQt5Core"
1552 if test_compile "$LIBQT5 $LIBPTHREAD $I_INCQT5 $FLGQT5" qt5 qt5 nofatal &&
1553 test_execute_path "`strip_L "$LIBQT5"`" nofatal; then
1554 foundqt5=1 # no pkg-config, Qt directory
1555 break;
1556 fi
1557 done
1558 fi
1559 fi
1560 if [ -n "$foundqt5" ]; then
1561 # We decided which version of Qt to use, now enforce the version requirement:
1562 cat > $ODIR.tmp_src.cc << EOF
1563#include <cstdio>
1564#include <QtGlobal>
1565extern "C" int main(void)
1566{
1567 printf("found version %s", QT_VERSION_STR);
1568EOF
1569 echo "#if QT_VERSION >= $(($QT5MAJ*65536+$QT5MIN*256))" >> $ODIR.tmp_src.cc
1570 cat >> $ODIR.tmp_src.cc << EOF
1571 printf(", OK.\n");
1572 return 0;
1573#else
1574EOF
1575echo " printf(\", expected version $QT5MAJ.$QT5MIN or higher\\\\n\");" >> $ODIR.tmp_src.cc
1576 cat >> $ODIR.tmp_src.cc << EOF
1577 return 1;
1578#endif
1579}
1580EOF
1581 [ -n "$INCQT5" ] && I_INCQT5=`prefix_I "$INCQT5"`
1582 if test_compile "$LIBQT5 $LIBPTHREAD $I_INCQT5 $FLGQT5" qt5 qt5 nofatal; then
1583 if test_execute_path "`strip_L "$LIBQT5"`"; then
1584 if [ "$OS" = "darwin" ]; then
1585 # Successful build & run the test application so add the necessary
1586 # params to AutoConfig.kmk:
1587 cnf_append "PATH_SDK_QT5_INC" "$PATH_SDK_QT5/Frameworks"
1588 cnf_append "PATH_SDK_QT5_LIB" "$PATH_SDK_QT5/Frameworks"
1589 cnf_append "PATH_SDK_QT5" "$PATH_SDK_QT5/Frameworks"
1590 # Check for the moc tool in the Qt directory found & some standard
1591 # directories.
1592 for q in $PATH_SDK_QT5 /usr /Developer/Tools/Qt; do
1593 if which_wrapper "$q/bin/moc" > /dev/null; then
1594 cnf_append "PATH_TOOL_QT5_BIN" "$q/bin"
1595 fi
1596 done
1597 else
1598 # Strip .../QtCore as we add components ourself:
1599 INCQT5=`echo "$INCQT5"|$KBUILD_SED 's|\([^ ]*\)/QtCore|\1|g; s| $||g'`
1600 # store only the first path, remove all other paths
1601 # most likely pkg-config gave us -I/usr/include/qt5 -I/usr/include/qt5/QtCore
1602 INCQT5=`echo "$INCQT5"|$KBUILD_SED 's|\([^ ]*\) .*|\1|'`
1603 cnf_append "VBOX_PATH_QT_LIB" "`strip_L "$LIBQT5"`"
1604 cnf_append "PATH_SDK_QT5_INC" "$INCQT5"
1605 # This is not quite right since the qt libpath does not have to be first...
1606 cnf_append "PATH_SDK_QT5_LIB" '$'"(firstword `strip_L "$LIBQT5"`)"
1607 if [ "$foundqt5" = "2" ]; then
1608 cnf_append "VBOX_WITH_ORACLE_QT" "1"
1609 fi
1610 if [ "$foundqt5" != "3" ]; then
1611 TOOLQT5BIN="$TOOLQT5/bin"
1612 fi
1613 test_header "Qt5 devtools"
1614 # Try it with a suffix, some platforms use that
1615 if which_wrapper "$TOOLQT5BIN/moc-qt5" > /dev/null; then
1616 QT5BINSUFF="-qt5"
1617 else
1618 QT5BINSUFF=""
1619 fi
1620 moc_ver=`$TOOLQT5BIN/moc$QT5BINSUFF -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1621 if [ $? -ne 0 ]; then
1622 log_failure "moc$QT5BINSUFF not working"
1623 fail
1624 else
1625 log_success "found version $moc_ver"
1626 cnf_append "VBOX_PATH_QT" "$TOOLQT5"
1627 cnf_append "PATH_SDK_QT5" "$TOOLQT5"
1628 cnf_append "PATH_TOOL_QT5_BIN" "$TOOLQT5BIN"
1629 [ -n "$QT5BINSUFF" ] && cnf_append "TOOL_QT5_BIN_SUFF" "$QT5BINSUFF"
1630 fi
1631 fi
1632 fi
1633 else
1634 log_failure "qt5 not working"
1635 fail
1636 fi
1637 else
1638 log_failure "qt5 not found"
1639 fail
1640 fi
1641}
1642
1643
1644#
1645# Check for libopus
1646#
1647check_libopus()
1648{
1649 if [ -z "$BUILD_LIBOPUS" ]; then
1650 test_header libopus
1651 if which_wrapper pkg-config > /dev/null; then
1652 libopus_ver=`pkg-config opus --modversion 2>> $LOG`
1653 if [ $? -eq 0 ]; then
1654 FLGOPUS=`pkg-config opus --cflags`
1655 INCOPUS=`strip_I "$FLGOPUS"`
1656 LIBOPUS=`pkg-config opus --libs`
1657 fi
1658 cat > $ODIR.tmp_src.cc << EOF
1659#include <cstdio>
1660#include <opus/opus.h>
1661extern "C" int main(void)
1662{
1663 OpusEncoder *test;
1664 printf("found, OK.\n");
1665}
1666EOF
1667 [ -n "$INCOPUS" ] && I_INCOPUS=`prefix_I "$INCOPUS"`
1668 if test_compile "$LIBOPUS $I_INCOPUS" opus opus; then
1669 if test_execute; then
1670 cnf_append "SDK_VBOX_OPUS_INCS" "$INCOPUS"
1671 cnf_append "SDK_VBOX_OPUS_LIBS" "`strip_l "$LIBOPUS"`"
1672 fi
1673 fi
1674 fi
1675 fi
1676}
1677
1678
1679#
1680# Check for libvpx
1681#
1682check_vpx()
1683{
1684 if [ -z "$BUILD_LIBVPX" ]; then
1685 test_header libvpx
1686 if which_wrapper pkg-config > /dev/null; then
1687 libvpx_ver=`pkg-config vpx --modversion 2>> $LOG`
1688 if [ $? -eq 0 ]; then
1689 FLGVPX=`pkg-config vpx --cflags`
1690 INCVPX=`strip_I "$FLGVPX"`
1691 LIBVPX=`pkg-config vpx --libs`
1692 fi
1693 cat > $ODIR.tmp_src.cc << EOF
1694#include <cstdio>
1695#include <vpx/vpx_codec.h>
1696extern "C" int main(void)
1697{
1698 int version = vpx_codec_version();
1699 int verMajor = VPX_VERSION_MAJOR(version);
1700 int verMinor = VPX_VERSION_MINOR(version);
1701 int verPatch = VPX_VERSION_PATCH(version);
1702 printf("found version %d.%d.%d", verMajor, verMinor, verPatch);
1703 if ( verMajor == 1 && verMinor >= 0
1704 || verMajor == 0 && verMinor == 9 && verPatch >= 5)
1705 {
1706 printf(", OK.\n");
1707 return 0;
1708 }
1709 else
1710 {
1711 printf(", expected version 0.9.5 or higher\n");
1712 return 1;
1713 }
1714}
1715EOF
1716 [ -n "$INCVPX" ] && I_INCVPX=`prefix_I "$INCVPX"`
1717 if test_compile "$LIBVPX $I_INCVPX" vpx vpx; then
1718 if test_execute; then
1719 cnf_append "SDK_VBOX_VPX_INCS" "$INCVPX"
1720 cnf_append "SDK_VBOX_VPX_LIBS" "`strip_l "$LIBVPX"`"
1721 fi
1722 fi
1723 fi
1724 fi
1725}
1726
1727
1728#
1729# Check whether static libstdc++ is installed. This library is required
1730# for the Linux guest additions.
1731#
1732check_staticlibstdcxx()
1733{
1734 test_header "static stc++ library"
1735 libstdcxx=`$CXX -print-file-name=libstdc++.a`
1736 cat > $ODIR.tmp_src.cc << EOF
1737#include <string>
1738
1739extern "C" int main(void)
1740{
1741 std::string s = "test";
1742 return 0;
1743}
1744EOF
1745 if test_compile "$libstdcxx" libstdc++ libstdc++; then
1746 log_success "found"
1747 fi
1748}
1749
1750
1751#
1752# Check for Linux sources
1753#
1754check_linux()
1755{
1756 test_header "Linux kernel sources"
1757 cat > $ODIR.tmp_src.c << EOF
1758#include <linux/version.h>
1759int printf(const char *format, ...);
1760int main(void)
1761{
1762 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
1763 (LINUX_VERSION_CODE % 65536) / 256,
1764 LINUX_VERSION_CODE % 256);
1765#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
1766 printf(", OK.\n");
1767 return 0;
1768#else
1769 printf(", expected version 2.4.0 or higher\n");
1770 return 1;
1771#endif
1772}
1773EOF
1774 echo "compiling the following source file:" >> $LOG
1775 cat $ODIR.tmp_src.c >> $LOG
1776 echo "using the following command line:" >> $LOG
1777 echo "$CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include " \
1778 "-I$LINUX/include/generated/uapi" >> $LOG
1779 $CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include \
1780 -I$LINUX/include/generated/uapi >> $LOG 2>&1
1781 if [ $? -ne 0 ]; then
1782 echo
1783 echo " Linux kernel headers not found at $LINUX"
1784 echo " Check the file $LOG for detailed error information."
1785 fail
1786 else
1787 if test_execute; then
1788 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
1789 fi
1790 fi
1791}
1792
1793#
1794# Check for kchmviewer, needed to display the online help
1795# (unused as we ship kchmviewer)
1796#
1797check_kchmviewer()
1798{
1799 test_header kchmviewer
1800 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
1801 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
1802 if [ $? -ne 0 ]; then
1803 log_failure "kchmviewer not working"
1804 fail
1805 else
1806 log_success "found version $kchmviewer_ver"
1807 fi
1808 fi
1809}
1810
1811
1812#
1813# Check for the kBuild tools, we don't support GNU make
1814#
1815check_kbuild()
1816{
1817 test_header kBuild
1818 if which_wrapper "$KBUILDDIR/bin/$OS.$BUILD_MACHINE/kmk" > /dev/null; then
1819 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$BUILD_MACHINE"
1820 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1821 echo "export PATH_KBUILD" >> $ENV
1822 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1823 echo "export PATH_DEVTOOLS" >> $ENV
1824 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1825 echo "export PATH_KBUILD_BIN" >> $ENV
1826 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1827 if [ "$OS" = "solaris" ]; then
1828 # Because of sh being non-default shell in Solaris we need to export PATH again when
1829 # sourcing env.sh. Simply exporting from ./configure does not export PATH correctly.
1830 echo "PATH=\"$ORGPATH\"" >> $ENV
1831 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1832 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1833 else
1834 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1835 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1836 fi
1837 echo "export PATH" >> $ENV
1838 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1839 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1840 elif [ "$OS.$BUILD_MACHINE" = "darwin.amd64" ]; then
1841 # Currently there are no amd64 kBuild bins. So use the x86 variant in any case.
1842 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.x86"
1843 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1844 echo "export PATH_KBUILD" >> $ENV
1845 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1846 echo "export PATH_DEVTOOLS" >> $ENV
1847 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.x86\"" >> $ENV
1848 echo "PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
1849 echo "export PATH_KBUILD_BIN" >> $ENV
1850 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1851 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1852 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1853 echo "export PATH" >> $ENV
1854 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1855 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1856 elif check_avail "kmk" KBUILDDIR really; then
1857 # check for installed kBuild
1858 KBUILD_SED="`which_wrapper kmk_sed`"
1859 else
1860 fail
1861 fi
1862 log_success "found"
1863}
1864
1865
1866#
1867# Check for compiler.h
1868# Some Linux distributions include "compiler.h" in their libc linux
1869# headers package, some don't. Most don't need it, building might (!)
1870# not succeed on openSUSE without it.
1871#
1872# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
1873#
1874check_compiler_h()
1875{
1876 test_header compiler.h
1877 if test ! -f "/usr/include/linux/compiler.h"; then
1878 log_success "compiler.h not found"
1879 else
1880 cnf_append "VBOX_WITH_LINUX_COMPILER_H" "1"
1881 log_success "compiler.h found"
1882 fi
1883}
1884
1885#
1886# Check for libcap.
1887# Required to pass CAP_NET_RAW to our binaries to allow to open SOCK_RAW
1888# sockets for doing ICMP requests.
1889#
1890check_libcap()
1891{
1892 test_header "libcap library"
1893 cat > $ODIR.tmp_src.cc << EOF
1894#include <cstdio>
1895#include <sys/types.h>
1896#include <linux/types.h>
1897#include <sys/capability.h>
1898
1899extern "C" int main(void)
1900{
1901 char buf[1024];
1902 cap_t caps = cap_get_proc();
1903 snprintf(buf, sizeof(buf), "Current caps are '%s'\n", cap_to_text(caps, NULL));
1904 return 0;
1905}
1906EOF
1907 if test_compile $LIBCAP libcap libcap; then
1908 if test_execute; then
1909 log_success "found"
1910 fi
1911 fi
1912}
1913
1914#
1915# Check if we are able to build 32-bit applications (needed for the guest additions)
1916#
1917check_32bit()
1918{
1919 test_header "32-bit support"
1920 cat > $ODIR.tmp_src.c << EOF
1921#include <stdint.h>
1922int main(void)
1923{
1924 return 0;
1925}
1926EOF
1927 echo "compiling the following source file:" >> $LOG
1928 cat $ODIR.tmp_src.c >> $LOG
1929 echo "using the following command line:" >> $LOG
1930 echo "$CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
1931 $CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
1932 if [ $? -ne 0 ]; then
1933 echo
1934 echo " Cannot compile 32-bit applications (missing headers and/or libraries)!"
1935 echo " Check the file $LOG for detailed error information."
1936 fail
1937 else
1938 echo "executing the binary" >> $LOG
1939 $ODIR.tmp_out 2> $ODIR.test_execute.log
1940 rc=$?
1941 cat $ODIR.test_execute.log >> $LOG
1942 if [ $rc -ne 0 ]; then
1943 echo
1944 echo " Cannot execute 32-bit applications! Either enable 32-bit support in the"
1945 echo " kernel configuration or use --disable-vmmraw to disable 32-bit guests."
1946 fail
1947 return 1
1948 fi
1949 fi
1950 log_success ""
1951}
1952
1953
1954#
1955# Check for Python
1956#
1957check_python()
1958{
1959 test_header "Python support"
1960
1961 # On darwin this is a on/off decision only
1962 if [ "$OS" = "darwin" ]; then
1963 echo "enabled"
1964 cnf_append "VBOX_WITH_PYTHON" "1"
1965 return
1966 fi
1967
1968 cat > $ODIR.tmp_src.cc << EOF
1969#include <cstdio>
1970#include <Python.h>
1971extern "C" int main(void)
1972{
1973 Py_Initialize();
1974 printf("found version %s", PY_VERSION);
1975#if PY_VERSION_HEX >= 0x02060000
1976 printf(", OK.\n");
1977 return 0;
1978#else
1979 printf(", expected version 2.6 or higher\n");
1980 return 1;
1981#endif
1982}
1983EOF
1984 found=
1985 SUPPYTHONLIBS="python2.7 python2.6 python3.1 python3.2 python3.3 python3.4 python3.4m python3.5 python3.5m python3.6 python3.6m"
1986 for p in $PYTHONDIR; do
1987 for d in $SUPPYTHONLIBS; do
1988 for b in lib/x86_64-linux-gnu lib/i386-linux-gnu lib64 lib/64 lib; do
1989 echo "compiling the following source file:" >> $LOG
1990 cat $ODIR.tmp_src.cc >> $LOG
1991 echo "using the following command line:" >> $LOG
1992 echo "$CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so" >> $LOG
1993 $CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so >> $LOG 2>&1
1994 if [ $? -eq 0 ]; then
1995 found=1
1996 break
1997 fi
1998 done
1999 if [ -n "$found" ]; then break; fi
2000 done
2001 if [ -n "$found" ]; then break; fi
2002 done
2003 if [ -n "$found" ]; then
2004 if test_execute; then
2005 cnf_append "VBOX_WITH_PYTHON" "1"
2006 cnf_append "VBOX_PATH_PYTHON_INC" "$p/include/$d"
2007 cnf_append "VBOX_LIB_PYTHON" "$p/$b/lib$d.so"
2008 else
2009 log_failure "Python not working"
2010 fail
2011 fi
2012 else
2013 log_failure "Python not found"
2014 fail
2015 fi
2016}
2017
2018
2019#
2020# Check for Java
2021#
2022check_java()
2023{
2024 test_header "Java support"
2025 log_success
2026}
2027
2028
2029#
2030# Setup wine
2031#
2032setup_wine()
2033{
2034 test_header "Wine support"
2035 if ! which_wrapper wine > /dev/null; then
2036 echo " wine binary not found"
2037 fail
2038 fi
2039 if ! which_wrapper wine > /dev/null; then
2040 echo " wine not found"
2041 fail
2042 fi
2043 wine_version="`wine --version`"
2044 case "`expr "$wine_version" : 'wine-\([0-9.]*\)' '>' 1.1.43`" in
2045 "0")
2046 if ! which_wrapper wineprefixcreate > /dev/null; then
2047 echo " wineprefixcreate not found"
2048 fail
2049 fi
2050 ;;
2051 *) eval "wineprefixcreate() { true ; }" ;; # now created automatically
2052 esac
2053 export WINEPREFIX="${ODIR}wine.$BUILD_MACHINE"
2054 echo "WINEPREFIX=\"${ODIR}wine.$BUILD_MACHINE\"" >> $ENV
2055 echo "export WINEPREFIX" >> $ENV
2056 rm -rf $WINEPREFIX
2057 mkdir -p $WINEPREFIX
2058 touch $WINEPREFIX/.no_prelaunch_window_flag
2059 if ! wineprefixcreate -q > /dev/null 2>&1; then
2060 echo " wineprefixcreate failed"
2061 fail
2062 fi
2063 tmp=.tmp.wine.reg
2064 rm -f $tmp
2065 echo 'REGEDIT4' > $tmp
2066 echo '' >> $tmp
2067 echo '[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Session Manager\Environment]' >> $tmp
2068 echo "\"PATH\"=\"c:\\\\\\\\windows\\\\\\\\system32;c:\\\\\\\\windows;z:$DEVDIR/win.x86/vcc/v8/bin/Microsoft.VC80.CRT;z:$DEVDIR/win.x86/HTML_Help_Workshop/v1.3\"" >> $tmp
2069 echo '' >> $tmp
2070 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhc.exe\DllOverrides]' >> $tmp
2071 echo '"itss"="native"' >> $tmp
2072 echo '' >> $tmp
2073 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhw.exe\DllOverrides]' >> $tmp
2074 echo '"itss"="native"' >> $tmp
2075 echo '' >> $tmp
2076 if ! wine regedit $tmp > /dev/null 2>&1; then
2077 rm -f $tmp
2078 echo " failed to load registry changes (path)."
2079 fail
2080 fi
2081 rm -f $tmp
2082 log_success "found"
2083}
2084
2085
2086#
2087# Check for gSOAP.
2088#
2089check_gsoap()
2090{
2091 test_header "GSOAP compiler"
2092 if [ -z "$GSOAP" -a -z "$GSOAP_IMPORT" ]; then
2093 if which_wrapper pkg-config > /dev/null; then
2094 GSOAP_CXX_LIBS=`pkg-config gsoapssl++ --libs 2>> $LOG`
2095 if [ $? -eq 0 ]; then
2096 GSOAP=`pkg-config gsoapssl++ --variable=exec_prefix`
2097 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
2098 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
2099 GSOAP_IMPORT="$GSOAP/include/gsoap"
2100 fi
2101 cnf_append "VBOX_GSOAP_INSTALLED" "1"
2102 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
2103 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
2104 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
2105 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
2106 else
2107 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
2108 fi
2109 cnf_append "VBOX_GSOAP_CXX_LIBS" "`strip_l "$GSOAP_CXX_LIBS"`"
2110 gsoap_version=`pkg-config gsoapssl++ --modversion`
2111 log_success "found version $gsoap_version"
2112 return
2113 fi
2114 fi
2115 fi
2116 if [ -z "$GSOAP" ]; then
2117 GSOAP="/usr"
2118 fi
2119 if which_wrapper "$GSOAP/bin/soapcpp2" > /dev/null; then
2120 if which_wrapper "$GSOAP/bin/wsdl2h" > /dev/null; then
2121 if [ -f "$GSOAP/include/stdsoap2.h" ]; then
2122 # TODO: Check for libgsoap++.a/so
2123
2124 if [ -z "$GSOAP_IMPORT" ]; then
2125 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
2126 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
2127 GSOAP_IMPORT="$GSOAP/include/gsoap"
2128 fi
2129 fi
2130 if [ -f "$GSOAP_IMPORT/stlvector.h" ]; then
2131 cnf_append "VBOX_GSOAP_INSTALLED" "1"
2132 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
2133 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
2134 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
2135 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
2136 else
2137 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
2138 fi
2139 cnf_append "VBOX_GSOAP_CXX_LIBS" "libgsoapssl++"
2140 log_success "found"
2141 else
2142 log_failure "stlvector.h not found -- disabling webservice"
2143 cnf_append "VBOX_WITH_WEBSERVICES" ""
2144 fi
2145 else
2146 log_failure "stdsoap2.h not found -- disabling webservice"
2147 cnf_append "VBOX_WITH_WEBSERVICES" ""
2148 fi
2149 else
2150 log_failure "wsdl2h not found -- disabling webservice"
2151 cnf_append "VBOX_WITH_WEBSERVICES" ""
2152 fi
2153 else
2154 log_failure "soapcpp2 not found -- disabling webservice"
2155 cnf_append "VBOX_WITH_WEBSERVICES" ""
2156 fi
2157}
2158
2159
2160#
2161# Check Xcode path
2162#
2163check_xcode_sdk_path()
2164{
2165 # Check if WITH_XCODE_DIR is set.
2166 if [ -z "$WITH_XCODE_DIR" ]; then
2167 echo "Please specify --with-xcode-dir option."
2168 return 0
2169 fi
2170
2171 # Check if specified path exists and is a directory.
2172 if [ -d "$1" ]; then
2173 return 1
2174 else
2175 echo "Xcode path [$1] not found."
2176 return 0
2177 fi
2178}
2179
2180#
2181# Determines the Darwin version.
2182# @todo This should really check the Xcode/SDK version.
2183#
2184check_darwinversion()
2185{
2186 test_header "Darwin version"
2187 darwin_ver=`uname -r`
2188 case "$darwin_ver" in
2189 17\.*)
2190 check_xcode_sdk_path "$WITH_XCODE_DIR"
2191 [ $? -eq 1 ] || fail
2192 darwin_ver="10.13" # High Sierra
2193 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2194 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2195 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2196 ;;
2197 16\.*)
2198 check_xcode_sdk_path "$WITH_XCODE_DIR"
2199 [ $? -eq 1 ] || fail
2200 darwin_ver="10.12" # Sierra
2201 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2202 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2203 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2204 ;;
2205 15\.*)
2206 check_xcode_sdk_path "$WITH_XCODE_DIR"
2207 [ $? -eq 1 ] || fail
2208 darwin_ver="10.11" # El Capitan
2209 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2210 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2211 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2212 ;;
2213 14\.*)
2214 check_xcode_sdk_path "$WITH_XCODE_DIR"
2215 [ $? -eq 1 ] || fail
2216 darwin_ver="10.10" # Yosemite
2217 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2218 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2219 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2220 ;;
2221 13\.*)
2222 check_xcode_sdk_path "$WITH_XCODE_DIR"
2223 [ $? -eq 1 ] || fail
2224 darwin_ver="10.9" # Mavericks
2225 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2226 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2227 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2228 ;;
2229 12\.*)
2230 darwin_ver="10.8" # Mountain Lion
2231 if [ ! -z "$WITH_XCODE_DIR" ]; then
2232 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2233 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2234 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2235 else
2236 sdk=/Developer/SDKs/MacOSX10.6.sdk
2237 fi
2238 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2239 ;;
2240 11\.*)
2241 darwin_ver="10.7" # Lion
2242 sdk=/Developer/SDKs/MacOSX10.6.sdk
2243 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2244 ;;
2245 10\.*)
2246 darwin_ver="10.6" # Snow Leopard
2247 if [ "$BUILD_MACHINE" = "x86" ]; then
2248 sdk=/Developer/SDKs/MacOSX10.5.sdk
2249 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2250 cnf_append "VBOX_MACOS_10_5_WORKAROUND" "1"
2251 else
2252 sdk=/Developer/SDKs/MacOSX10.6.sdk
2253 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2254 fi
2255# test "$CC" = "gcc" && CC="gcc-4.0"
2256# test "$CXX" = "g++" && CXX="g++-4.0"
2257 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2258 ;;
2259 9\.*)
2260 darwin_ver="10.5" # Leopard
2261 sdk=/Developer/SDKs/MacOSX10.5.sdk
2262 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2263# test "$CC" = "gcc" && CC="gcc-4.0"
2264# test "$CXX" = "g++" && CXX="g++-4.0"
2265 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2266 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2267 ;;
2268 8\.*)
2269 darwin_ver="10.4" # Tiger
2270 sdk=/Developer/SDKs/MacOSX10.4u.sdk
2271 CXX_FLAGS="-mmacosx-version-min=10.4 -isysroot $sdk -Wl,-syslibroot,$sdk"
2272# test "$CC" = "gcc" && CC="gcc-4.0"
2273# test "$CXX" = "g++" && CXX="g++-4.0"
2274 cnf_append "VBOX_WITH_COCOA_QT" ""
2275 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2276 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2277 ;;
2278 *)
2279 echo " failed to determine Darwin version. (uname -r: $darwin_ver)"
2280 fail
2281 darwin_ver="unknown"
2282 ;;
2283 esac
2284 log_success "found version $darwin_ver (SDK: $sdk)"
2285}
2286
2287
2288check_makeself()
2289{
2290 test_header "makeself"
2291 if check_avail "$MAKESELF" makeself; then
2292 makeself_ver=`$MAKESELF --version|grep version|sed 's+^Makeself.*version \([0-9\.]*\).*+\1+'`
2293 if [ $? -ne 0 ]; then
2294 log_failure "makeself not working"
2295 fail
2296 else
2297 log_success "found version $makeself_ver"
2298 cnf_append "VBOX_MAKESELF" "`which_wrapper $MAKESELF`"
2299 fi
2300 fi
2301}
2302
2303
2304#
2305# Show help
2306#
2307show_help()
2308{
2309cat << EOF
2310Usage: ./configure [OPTIONS]...
2311
2312Configuration:
2313 -h, --help display this help and exit
2314 --nofatal don't abort on errors
2315EOF
2316[ $WITH_XPCOM -eq 1 ] && echo " --disable-xpcom disable XPCOM and related stuff"
2317[ $WITH_PYTHON -eq 1 ] && echo " --disable-python disable python bindings"
2318[ $WITH_JAVA -eq 1 ] && echo " --disable-java disable java bindings"
2319[ $WITH_VMMRAW -eq 1 ] && echo " --disable-vmmraw disable VMM raw mode (VT-x/AMD-V mandatory!)"
2320[ $WITH_SDL_TTF -eq 1 ] && echo " --disable-sdl-ttf disable SDL_ttf detection"
2321[ $WITH_QT5 -eq 1 ] && echo " --disable-qt disable Qt detection"
2322[ $WITH_ALSA -eq 1 ] && echo " --disable-alsa disable the ALSA sound backend"
2323[ $WITH_PULSE -eq 1 ] && echo " --disable-pulse disable the PulseAudio backend"
2324[ $WITH_DBUS -eq 1 ] && echo " --disable-dbus don't use DBus and hal for hardware detection"
2325[ $WITH_KMODS -eq 1 ] && echo " --disable-kmods don't build Linux kernel modules (host and guest)"
2326[ $WITH_OPENGL -eq 1 ] && echo " --disable-opengl disable OpenGL support (2D & 3D)"
2327[ $WITH_QT5 -eq 0 ] && echo " --enable-qt5 enable Qt5 detection"
2328[ $WITH_GSOAP -eq 0 ] && echo " --enable-webservice enable the webservice stuff"
2329[ $OSE -eq 1 ] && echo " --enable-vnc enable the VNC server"
2330[ $OSE -eq 0 ] && echo " --disable-extpack don't build the extpack"
2331[ $WITH_DOCS -eq 1 ] && echo " --disable-docs don't build the documentation"
2332[ $WITH_LIBVPX -eq 1 ] && echo " --disable-libvpx don't use libvpx for video capturing"
2333[ $WITH_LIBOPUS -eq 1 ] && echo " --disable-libopus don't use libopus for audio capturing"
2334[ "$OS" = "linux" -o "$OS" = "freebsd" ] && echo " --enable-vde enable VDE networking"
2335cat << EOF
2336 --disable-udptunnel disable UDP tunnel networking
2337 --disable-devmapper disable device mapper library access
2338 --disable-hardening don't be strict about /dev/vboxdrv access
2339 --build-libxml2 build libxml2 from sources
2340EOF
2341[ $OSE -eq 0 ] && cat << EOF
2342 --build-libssl build openssl from sources
2343 --build-libcurl build libcurl from sources
2344 --build-libvpx build libvpx from sources
2345EOF
2346[ "$OS" != "darwin" ] && echo " --setup-wine setup a Wine directory and register the hhc hack"
2347cat << EOF
2348 --only-additions only build the Guest Additions
2349
2350Paths:
2351 --with-gcc=PATH location of the gcc compiler [$CC]
2352 --with-g++=PATH location of the g++ compiler [$CXX]
2353 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
2354 --with-iasl=PATH location of the iasl compiler [$IASL]
2355 --with-makeself=PATH location of makeself [$MAKESELF]
2356EOF
2357[ "$OS" = "darwin" ] && echo " --with-xcode-dir=DIR custom path to Xcode root directory; it is assumed that Xcode"
2358[ "$OS" = "darwin" ] && echo " contains OS X 10.6 SDK (required for Mountain Lion and newer hosts"
2359[ "$OS" = "darwin" ] && echo " only, ignored for the rest)"
2360[ "$OS" = "linux" ] && echo " --with-linux=DIR Linux kernel source directory [$LINUX]"
2361[ $WITH_QT5 -eq 1 ] && echo " --with-qt-dir=DIR directory for Qt headers/libraries [pkgconfig]"
2362[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-dir=PATH directory for gSOAP compiler/headers/libraries"
2363[ $WITH_GSOAP -eq 1 ] && echo " (soapcpp2 and wsdl2h, soapstd2.h, libgsoap++.a/so)"
2364[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-import=PATH directory for gSOAP import files (stlvector.h)"
2365cat << EOF
2366 --with-openssl-dir=DIR directory for OpenSSL headers/libraries
2367 --with-ow-dir=DIR directory where Open Watcom can be found [$WATCOM]
2368 --out-path=PATH the folder to which configuration and build output
2369 should go
2370
2371Build type:
2372 -d, --build-debug build with debugging symbols and assertions
2373 --build-profile build with profiling support
2374 --build-headless build headless (without any GUI frontend)
2375EOF
2376 exit 0
2377}
2378
2379
2380#
2381# The body.
2382#
2383
2384# test if we are OSE
2385if [ $OSE -eq 1 -a -r "`cd \`dirname $0\`; pwd`/src/VBox/RDP/server/server.cpp" ]; then
2386 OSE=0
2387 # Set this as a reminder to print a log message once we know the path of the
2388 # log file
2389 NOT_OSE=1
2390fi
2391
2392# Change OS specific defaults; must be before all other stuff
2393if [ "$OS" = "darwin" ]; then
2394 WITH_SDL=0
2395 WITH_SDL_TTF=0
2396 WITH_X11=0
2397 WITH_ALSA=0
2398 WITH_PULSE=0
2399 WITH_DBUS=0
2400 WITH_KMODS=0
2401 BUILD_LIBXML2=1
2402 BUILD_LIBVPX=1
2403 [ $OSE -eq 1 ] || BUILD_LIBCURL=1
2404 [ $OSE -eq 1 ] && WITH_LIBVPX=0
2405 [ $OSE -eq 1 ] && WITH_LIBOPUS=0
2406 WITH_XCODE_DIR=""
2407elif [ "$OS" = "haiku" ]; then
2408 #WITH_SDL=0
2409 WITH_SDL_TTF=0
2410 WITH_X11=0
2411 WITH_ALSA=0
2412 WITH_PULSE=0
2413 WITH_DBUS=0
2414 WITH_KMODS=0
2415 WITH_LIBIDL=0
2416 WITH_XPCOM=0
2417 BUILD_LIBXSLT=1
2418 BUILD_LIBXML2=1
2419 WITH_LIBVPX=0
2420 WITH_LIBOPUS=0
2421 # it is part of libroot, which is linked by default,
2422 # but the script wants something
2423 LIBPTHREAD="-lroot"
2424 #[ $OSE -eq 1 ] || BUILD_LIBCURL=1
2425 [ $OSE -eq 1 ] || BUILD_LIBSSL=1
2426elif [ "$OS" = "solaris" ]; then
2427 [ $OSE -eq 1 ] && WITH_LIBVPX=0
2428 [ $OSE -eq 1 ] && WITH_LIBOPUS=0
2429fi
2430
2431# scan command line options
2432for option in "$@"; do
2433 case "$option" in
2434 --help|-help|-h)
2435 show_help
2436 ;;
2437 --nofatal)
2438 nofatal=1
2439 ;;
2440 --env-only)
2441 ENV_ONLY=1
2442 ;;
2443 --with-gcc=*)
2444 CC=`echo $option | cut -d'=' -f2`
2445 ;;
2446 --with-g++=*)
2447 CXX=`echo $option | cut -d'=' -f2`
2448 ;;
2449 --with-kbuild=*)
2450 KBUILDDIR=`echo $option | cut -d'=' -f2`
2451 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
2452 echo "Error: KBUILDDIR contains invalid characters!"
2453 exit 1
2454 fi
2455 ;;
2456 --with-qt-dir=*)
2457 [ $WITH_QT5 -eq 1 ] && QT5DIR=`echo $option | cut -d'=' -f2`
2458 [ $WITH_QT5 -eq 1 ] && QT5DIR_PKGCONFIG=0
2459 ;;
2460 --with-qt5-minor=*)
2461 QT5MIN=`echo $option | cut -d'=' -f2`
2462 ;;
2463 --with-qt5-major=*)
2464 QT5MAJ=`echo $option | cut -d'=' -f2`
2465 ;;
2466 --with-openssl-dir=*)
2467 OPENSSLDIR=`echo $option | cut -d'=' -f2`
2468 INCCRYPTO="-I${OPENSSLDIR}/include"
2469 LIBCRYPTO="${OPENSSLDIR}/lib/libcrypto.a ${OPENSSLDIR}/lib/libssl.a"
2470 ;;
2471 --with-ow-dir=*)
2472 WATCOM=`echo $option | cut -d'=' -f2`
2473 ;;
2474 --with-gsoap-dir=*)
2475 GSOAP=`echo $option | cut -d'=' -f2`
2476 ;;
2477 --with-gsoap-import=*)
2478 GSOAP_IMPORT=`echo $option | cut -d'=' -f2`
2479 ;;
2480 --with-iasl=*)
2481 IASL=`echo $option | cut -d'=' -f2`
2482 ;;
2483 --with-xcode-dir=*)
2484 WITH_XCODE_DIR=`echo $option | cut -d'=' -f2`
2485 echo $option
2486 ;;
2487 --with-linux=*)
2488 LINUX=`echo $option | cut -d'=' -f2`
2489 ;;
2490 --with-makeself=*)
2491 MAKESELF=`echo $option | cut -d'=' -f2`
2492 ;;
2493 --target-arch=*)
2494 TARGET_MACHINE=`echo $option | cut -d'=' -f2`
2495 ;;
2496 --disable-xpcom)
2497 [ $WITH_XPCOM -eq 1 ] && WITH_XPCOM=0
2498 ;;
2499 --disable-python)
2500 [ $WITH_PYTHON -eq 1 ] && WITH_PYTHON=0
2501 ;;
2502 --disable-java)
2503 [ $WITH_JAVA -eq 1 ] && WITH_JAVA=0
2504 ;;
2505 --disable-vmmraw)
2506 [ $WITH_VMMRAW -eq 1 ] && WITH_VMMRAW=0
2507 ;;
2508 --disable-sdl-ttf)
2509 [ $WITH_SDL_TTF -eq 1 ] && WITH_SDL_TTF=0
2510 ;;
2511 --disable-qt)
2512 [ $WITH_QT5 -eq 1 ] && WITH_QT5=0
2513 ;;
2514 --enable-qt5)
2515 [ $WITH_QT5 -eq 0 ] && WITH_QT5=1
2516 ;;
2517 --passive-mesa)
2518 PASSIVE_MESA=1
2519 ;;
2520 --disable-alsa)
2521 [ $WITH_ALSA -eq 1 ] && WITH_ALSA=0
2522 ;;
2523 --disable-pulse)
2524 [ $WITH_PULSE -eq 1 ] && WITH_PULSE=0
2525 ;;
2526 --enable-pulse)
2527 WITH_PULSE=2
2528 ;;
2529 --disable-dbus)
2530 [ $WITH_DBUS -eq 1 ] && WITH_DBUS=0
2531 ;;
2532 --disable-kmods)
2533 [ $WITH_KMODS -eq 1 ] && WITH_KMODS=0
2534 ;;
2535 --disable-opengl)
2536 [ $WITH_OPENGL -eq 1 ] && WITH_OPENGL=0
2537 ;;
2538 --enable-webservice)
2539 [ $WITH_GSOAP -eq 0 ] && WITH_GSOAP=1
2540 ;;
2541 --enable-vnc)
2542 WITH_VNC=1
2543 ;;
2544 --disable-hardening)
2545 WITH_HARDENING=0
2546 ;;
2547 --disable-extpack)
2548 WITH_EXTPACK=0
2549 ;;
2550 --disable-docs)
2551 WITH_DOCS=0
2552 ;;
2553 --enable-hardening)
2554 WITH_HARDENING=2
2555 ;;
2556 --build-libopus)
2557 BUILD_LIBOPUS=1
2558 ;;
2559 --disable-udptunnel)
2560 WITH_UDPTUNNEL=0
2561 ;;
2562 --enable-vde)
2563 WITH_VDE=1
2564 ;;
2565 --disable-devmapper)
2566 WITH_DEVMAPPER=0
2567 ;;
2568 --disable-libvpx)
2569 WITH_LIBVPX=0
2570 ;;
2571 --disable-libopus)
2572 WITH_LIBOPUS=0
2573 ;;
2574 --disable-sdl)
2575 WITH_SDL=0
2576 ;;
2577 --build-debug|-d)
2578 BUILD_TYPE=debug
2579 ;;
2580 --build-profile)
2581 BUILD_TYPE=profile
2582 ;;
2583 --build-libxml2)
2584 BUILD_LIBXML2=1
2585 ;;
2586 --build-libssl)
2587 BUILD_LIBSSL=1
2588 ;;
2589 --build-libcurl)
2590 BUILD_LIBCURL=1
2591 ;;
2592 --build-libvpx)
2593 BUILD_LIBVPX=1
2594 ;;
2595 --build-headless)
2596 HEADLESS=1
2597 WITH_SDL=0
2598 WITH_SDL_TTF=0
2599 WITH_X11=0
2600 WITH_OPENGL=0
2601 WITH_QT5=0
2602 ;;
2603 --ose)
2604 OSE=2
2605 ;;
2606 --odir=*)
2607 ODIR="`echo $option | cut -d'=' -f2`/"
2608 ODIR_OVERRIDE=1
2609 ;;
2610 --out-path=*)
2611 out_path="`echo $option | cut -d'=' -f2`/"
2612 if [ -d $out_path ]; then
2613 saved_path="`pwd`"
2614 cd $out_path
2615 OUT_PATH="`pwd`"
2616 cd $saved_path
2617 OUT_PATH_OVERRIDE=1
2618 if [ $ODIR_OVERRIDE -eq 0 ]; then
2619 # This variable has not *yet* been overridden. That can still happen.
2620 ODIR=$OUT_PATH/
2621 fi
2622 else
2623 echo "Error: invalid folder \"$out_path\" in option \"$option\""
2624 exit 1
2625 fi
2626 ;;
2627 --setup-wine)
2628 [ "$OS" != "darwin" ] && SETUP_WINE=1
2629 ;;
2630 --only-additions)
2631 ONLY_ADDITIONS=1
2632 ;;
2633 *)
2634 echo
2635 echo "Unrecognized option \"$option\""
2636 echo
2637 show_help
2638 ;;
2639 esac
2640done
2641
2642LOG="$ODIR$LOG"
2643ENV="$ODIR$ENV"
2644CNF="$ODIR$CNF"
2645
2646# initialize output files
2647cat > $LOG << EOF
2648# Log file generated by
2649#
2650# '$0 $*'
2651#
2652
2653EOF
2654cat > $CNF << EOF
2655# -*- Makefile -*-
2656#
2657# automatically generated by
2658#
2659# '$0 $*'
2660#
2661# It will be completely overwritten if configure is executed again.
2662#
2663
2664EOF
2665cat > $ENV << EOF
2666#!/bin/bash
2667#
2668# automatically generated by
2669#
2670# '$0 $*'
2671#
2672# It will be completely overwritten if configure is executed again.
2673# Make sure you source this file once before you start to build VBox.
2674#
2675
2676EOF
2677
2678# Print log warning about OSE if necessary
2679if [ -n "$NOT_OSE" ]; then
2680 echo "Found RDP server, assuming VBOX_OSE = FALSE" >> $LOG
2681 echo >> $LOG
2682fi
2683
2684
2685if [ "$BUILD_TYPE" = "debug" ]; then
2686 echo "Creating DEBUG build!" >> $LOG
2687elif [ "$BUILD_TYPE" = "profile" ]; then
2688 echo "Creating PROFILE build!" >> $LOG
2689fi
2690
2691# first determine our environment
2692check_environment
2693check_kbuild
2694
2695[ -n "$ENV_ONLY" ] && exit 0
2696
2697# append the tools directory to the default search path
2698echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
2699export PATH
2700
2701# if we will be writing to a different out directory then set this up now
2702if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2703 echo "AUTOCFG=$OUT_PATH/AutoConfig.kmk" >> $ENV
2704 echo "export AUTOCFG" >> $ENV
2705 echo "LOCALCFG=$OUT_PATH/LocalConfig.kmk" >> $ENV
2706 echo "export LOCALCFG" >> $ENV
2707 echo "PATH_OUT_BASE=$OUT_PATH" >> $ENV
2708 echo "export PATH_OUT_BASE" >> $ENV
2709fi
2710
2711# don't bother people with -Werror
2712cnf_append "VBOX_GCC_WERR" "\$(NO_SUCH_VARIABLE)"
2713
2714# some things are not available in for OSE
2715if [ $OSE -ge 1 ]; then
2716 cnf_append "VBOX_OSE" "1"
2717 cnf_append "VBOX_WITH_VALIDATIONKIT" ""
2718 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
2719
2720 if [ "$OS" = "linux" ]; then
2721 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
2722 else
2723 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
2724 fi
2725 echo >> $CNF
2726fi
2727
2728# extpack
2729if [ $ONLY_ADDITIONS -eq 1 ]; then
2730 cnf_append "VBOX_WITH_EXTPACK_PUEL_BUILD" ""
2731elif [ $OSE -eq 0 ]; then
2732 if [ $WITH_EXTPACK -eq 1 ]; then
2733 BUILD_LIBSSL=1
2734 else
2735 cnf_append "VBOX_WITH_EXTPACK_PUEL_BUILD" ""
2736 fi
2737fi
2738
2739# headless
2740if [ -n "$HEADLESS" ]; then
2741 cnf_append "VBOX_HEADLESS" "1"
2742fi
2743
2744# emit disable directives corresponding to any --disable-xxx options.
2745if [ $WITH_OPENGL -eq 0 ]; then
2746 cnf_append "VBOX_WITH_CROGL" ""
2747 cnf_append "VBOX_WITH_VIDEOHWACCEL" ""
2748 cnf_append "VBOX_GUI_USE_QGL" ""
2749fi
2750[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
2751[ $WITH_QT5 -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
2752[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
2753[ $WITH_PYTHON -eq 0 ] && cnf_append "VBOX_WITH_PYTHON" ""
2754[ $WITH_JAVA -eq 0 ] && cnf_append "VBOX_WITH_JXPCOM" ""
2755[ $WITH_JAVA -eq 0 ] && cnf_append "VBOX_WITH_JWS" ""
2756[ $WITH_HARDENING -eq 0 ] && cnf_append "VBOX_WITHOUT_HARDENING" "1"
2757[ $WITH_HARDENING -eq 2 ] && cnf_append "VBOX_WITH_HARDENING" "2"
2758[ $WITH_VMMRAW -eq 0 ] && cnf_append "VBOX_WITH_RAW_MODE" ""
2759if [ $WITH_LIBVPX -eq 0 ]; then
2760 cnf_append "VBOX_WITH_LIBVPX" ""
2761 cnf_append "VBOX_WITH_RECORDING" ""
2762fi
2763if [ $WITH_LIBOPUS -eq 0 ]; then
2764 cnf_append "VBOX_WITH_LIBOPUS" ""
2765 cnf_append "VBOX_WITH_AUDIO_RECORDING" ""
2766fi
2767
2768# Darwin-specific
2769if [ "$OS" = "darwin" ]; then
2770 check_darwinversion
2771fi
2772# the tools
2773check_gcc
2774if [ $ONLY_ADDITIONS -eq 0 ]; then
2775 check_open_watcom
2776 [ "$OS" != "darwin" ] && check_iasl
2777 # don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
2778 # [ "$OS" != "darwin" ] && check_yasm
2779 [ "$OS" != "darwin" ] && check_xsltproc
2780fi
2781
2782# the libraries
2783if [ $ONLY_ADDITIONS -eq 0 ]; then
2784 [ "$OS" != "darwin" ] && check_pthread
2785 check_libxml2
2786 [ $WITH_LIBIDL -eq 1 ] && check_libidl
2787 check_ssl
2788 check_curl
2789 [ $WITH_LIBVPX -eq 1 ] && check_vpx
2790 [ $WITH_LIBOPUS -eq 1 ] && check_libopus
2791 [ "$OS" != "darwin" ] && check_z
2792 [ "$OS" != "darwin" ] && check_png
2793 [ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
2794 if [ $WITH_SDL -eq 1 ]; then
2795 check_sdl
2796 else
2797 cnf_append "VBOX_WITH_VBOXSDL" ""
2798 fi
2799 [ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
2800 [ $WITH_X11 -eq 1 ] && check_x
2801 # TODO check for xcomposite-dev (X11/extensions/Xcomposite.h, additions only)
2802 # TODO check for libxdamange-dev (X11/extensions/Xdamage.h, additions only)
2803 [ $WITH_X11 -eq 1 ] && check_xcursor
2804 [ $WITH_X11 -eq 1 ] && check_xinerama
2805 [ $WITH_X11 -eq 1 ] && check_xrandr
2806 [ $WITH_OPENGL -eq 1 ] && check_opengl
2807 [ $WITH_QT5 -eq 1 ] && check_qt5
2808 [ $WITH_PYTHON -eq 1 ] && check_python
2809 [ $WITH_JAVA -eq 1 ] && check_java
2810
2811 # PulseAudio
2812 if [ "$OS" = "linux" -o "$OS" = "freebsd" -o "$OS" = "netbsd" ]; then
2813 if [ $WITH_PULSE -eq 1 ]; then
2814 check_pulse
2815 elif [ $WITH_PULSE -eq 0 ]; then
2816 cnf_append "VBOX_WITH_AUDIO_PULSE" ""
2817 fi
2818 fi
2819fi
2820
2821# Linux-specific
2822if [ "$OS" = "linux" ]; then
2823 # don't check for the static libstdc++ in the PUEL version as we build the
2824 # additions at a dedicated box
2825 [ $OSE -ge 1 ] && check_staticlibstdcxx
2826 if [ $WITH_KMODS -eq 1 ]; then
2827 check_linux
2828 else
2829 cnf_append "VBOX_LINUX_SRC" ""
2830 cnf_append "VBOX_WITHOUT_LINUX_TEST_BUILDS" "1"
2831 fi
2832 if [ $ONLY_ADDITIONS -eq 0 ]; then
2833 if [ $WITH_ALSA -eq 1 ]; then
2834 check_alsa
2835 else
2836 cnf_append "VBOX_WITH_AUDIO_ALSA" ""
2837 fi
2838 if [ $WITH_DBUS -eq 0 ]; then
2839 cnf_append "VBOX_WITH_DBUS" ""
2840 fi
2841 if [ $WITH_DEVMAPPER -eq 1 ]; then
2842 check_libdevmapper
2843 else
2844 cnf_append "VBOX_WITH_DEVMAPPER" ""
2845 fi
2846 check_libcap
2847 fi
2848 check_compiler_h
2849 [ $ONLY_ADDITIONS -eq 0 -a "$BUILD_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 1 ] && check_32bit
2850 # tools/common/makeself*
2851 [ $OSE -ge 1 ] && check_makeself
2852fi
2853
2854[ -n "$SETUP_WINE" ] && setup_wine
2855
2856if [ $ONLY_ADDITIONS -eq 0 -a $WITH_GSOAP -eq 1 ]; then
2857 check_gsoap
2858else
2859 if [ $OSE -ge 1 ]; then
2860 cnf_append "VBOX_WITH_WEBSERVICES" ""
2861 fi
2862fi
2863
2864# UDPTUNNEL
2865if [ $ONLY_ADDITIONS -eq 0 -a $WITH_UDPTUNNEL -eq 0 ]; then
2866 cnf_append "VBOX_WITH_UDPTUNNEL" ""
2867fi
2868
2869# VDE
2870if [ $ONLY_ADDITIONS -eq 0 -a "$OS" = "linux" -o "$OS" = "freebsd" ]; then
2871 if [ $WITH_VDE -eq 1 ]; then
2872 cnf_append "VBOX_WITH_VDE" "1"
2873 fi
2874fi
2875
2876# DOCS
2877if [ $ONLY_ADDITIONS -eq 1 -o $WITH_DOCS -eq 0 ]; then
2878 cnf_append "VBOX_WITH_DOCS" ""
2879 cnf_append "VBOX_WITH_DOCS_PACKING" ""
2880fi
2881
2882# VNC server support
2883if [ $ONLY_ADDITIONS -eq 0 -a $OSE -ge 1 ]; then
2884 if [ $WITH_VNC = 1 ]; then
2885 check_vncserver
2886 else
2887 cnf_append "VBOX_WITH_EXTPACK_VNC" ""
2888 fi
2889fi
2890
2891if [ $ONLY_ADDITIONS -eq 1 ]; then
2892 cnf_append "VBOX_ONLY_ADDITIONS" "1"
2893fi
2894
2895# success!
2896echo
2897echo "Successfully generated '$CNF' and '$ENV'."
2898echo "Source '$ENV' once before you start to build VBox:"
2899echo ""
2900echo " source $ENV"
2901echo " kmk"
2902echo ""
2903if [ "$OS" = "linux" ]; then
2904 if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2905 vbox_out_path=$OUT_PATH
2906 else
2907 vbox_out_path=./out
2908 fi
2909 echo "To compile the kernel modules, do:"
2910 echo ""
2911 echo " cd $vbox_out_path/$OS.$TARGET_MACHINE/$BUILD_TYPE/bin/src"
2912 echo " make"
2913 echo ""
2914fi
2915if [ $ONLY_ADDITIONS -eq 1 ]; then
2916 echo ""
2917 echo " Tree configured to build only the Guest Additions"
2918 echo ""
2919elif [ $WITH_HARDENING -gt 0 ]; then
2920 echo ""
2921 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2922 echo " Hardening is enabled which means that the VBox binaries will not run from"
2923 echo " the binary directory. The binaries have to be installed suid root and some"
2924 echo " more prerequisites have to be fulfilled which is normally done by installing"
2925 echo " the final package. For development, the hardening feature can be disabled"
2926 echo " by specifying the --disable-hardening parameter. Please never disable that"
2927 echo " feature for the final distribution!"
2928 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2929 echo ""
2930else
2931 echo ""
2932 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2933 echo " Hardening is disabled. Please do NOT build packages for distribution with"
2934 echo " disabled hardening!"
2935 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2936 echo ""
2937fi
2938echo "Enjoy!"
2939cleanup
Note: See TracBrowser for help on using the repository browser.

© 2023 Oracle
ContactPrivacy policyTerms of Use